<?php

class berichte{

var $datei = 'berichte.xml';
var $daten;
var $_speicher;

function __construct(){
	$this->datei = PFAD_INCLUDE.'conf/'.$this->datei;
}

function datenfuercheckboxen(){
	# fuer die Uebersicht mit Checkboxen sind nur die Felder Titel und ID noetig
	$rueckgabe = array();
	foreach($this->daten as $id => $bericht){
		if(isset($bericht['gleinstellung'])){
			global $_gleinst;
			$wert = $_gleinst[$bericht['gleinstellung'][0]][$bericht['gleinstellung'][1]];
			if($wert != $bericht['gleinstellung'][2]){
				continue;
			}
		}
		$rueckgabe[] = array(
			'id'    => $id,
			'titel' => $bericht['titel']
		);
	}
	return $rueckgabe;
}

function einlesen(){
	$xml_parser = xml_parser_create();
	xml_set_object($xml_parser,$this);
	xml_set_element_handler($xml_parser, '_startelement', '_endelement');
	xml_set_character_data_handler($xml_parser, '_elementinhalt');
	$fh = fopen($this->datei, 'r');
	if($fh === false){
		die('could not open XML input');
	}
	while($data = fread($fh, 4096)){
		if(!xml_parse($xml_parser, $data, feof($fh))){
			die(sprintf("XML error: %s at line %d", xml_error_string(xml_get_error_code($xml_parser)), xml_get_current_line_number($xml_parser)));
		}
	}
	fclose($fh);
	xml_parser_free($xml_parser);
	foreach($this->daten as $id => $_inh){
		$this->daten[$id]['titel'] = trim($_inh['titel']);
		$this->daten[$id]['spalten'] = explode(';',$_inh['spalten']);
	}
}

function _startelement($parser, $name, $attrs) {
	$name = strtolower($name);
	$this->_speicher['element'] = $name;
	switch($name){
	case 'berichte':
		$this->daten = array();
		break;
	case 'bericht':
		$this->_speicher['id'] = $attrs['ID'];
		$this->daten[$this->_speicher['id']] = array();
		$this->daten[$this->_speicher['id']]['verlinken'] = (isset($attrs['VERLINKEN']) and $attrs['VERLINKEN']==1)?1:0;
		if(isset($attrs['GLEINSTELLUNG'])){
			$this->daten[$this->_speicher['id']]['gleinstellung'] = explode(';', $attrs['GLEINSTELLUNG'], 3);
		}
		break;
	case 'query':
	case 'spalten':
	case 'titel':
		$this->daten[$this->_speicher['id']][$name] = '';
		break;
	default:
		break;
	}
}

function _elementinhalt($parser, $daten){
	$zuparsendeelemente = array('query','spalten','titel');
	if($this->_speicher['element'] == 'query'){
		$this->daten[$this->_speicher['id']][$this->_speicher['element']] .= str_replace('DB_PREFIX',DB_PREFIX,$daten);
	}
	elseif(in_array($this->_speicher['element'],$zuparsendeelemente)){
		$this->daten[$this->_speicher['id']][$this->_speicher['element']] .= $daten;
	}
}

function _endelement($parser,$name){
}

} # Ende der Klasse, EOF
?>