<?php

class db{
	var $server;
	var $benutzername;
	var $passwort;
	var $datenbank;
	var $db;
	var $gesetzt = false;
	var $ergebnis;
	var $tmpl;
	var $anzahldbabfragen = 0;
	var $schreibschutz = false;
	var $geaendertetabellen = array();
	var $selectquerys = array();


	public function k($str){
		return mysqli_real_escape_string($this->db, $str);
	}


	function exportiereDatenbank($dateiname = '', $tabellen = array()){
	/*
	Sichert die Datenbank zu der in $_db eine Verbindung besteht.
	Parameter:
	- $dateiname: Der Dateiname der Datei (wenn er leer ist, werden die ausgelesenen Daten zurueckgegeben)
	- $tabellen:  Die Tabellen die gespeichert werden sollen (wenn keine angegeben werden,
		werden alle aus der Datenbank gesichert)
	*/
		if(count($tabellen)==0){
			$this->holeDaten('SHOW TABLES FROM `'.DB_NAME.'`', E_USER_ERROR, 'row');
			$tabellen = $this->baueArray(0,'#');
		}
		$ausg = '';
		$br = PHP_EOL;
		foreach($tabellen as $tab){
			$ausg .= '/* Tabelle "'.$tab.'" */'.$br;
			$ausg .= $this->_holeTabellenstruktur($tab,$br).$br.$br;
			$ausg .= $this->holeTabellendaten($tab,$br).$br.$br.$br;
		}
		if(empty($dateiname)){
			return $ausg;
		}
		else{
			$fh = fopen(PFAD_INCLUDE.'sicherung/'.$dateiname, 'w');
			fwrite($fh, $ausg, strlen($ausg));
			fclose($fh);
			return true;
		}
	}

	function _holeTabellenstruktur($tabelle,$br){
		$ausg = 'DROP TABLE IF EXISTS '.$tabelle.';'.$br;
		$this->holeDaten('SHOW CREATE TABLE '.$tabelle,E_USER_ERROR,'row');
		$ausg .= $this->holeWert(1);
		$this->holeDaten("SHOW TABLE STATUS LIKE '".$tabelle."'");
		$ai = $this->holeWert('Auto_increment');
		if(!empty($ai)){
			$ausg .= ' AUTO_INCREMENT='.$ai;
		}
		$ausg .= ';';
		return $ausg;
	}

	function holeTabellendaten($tabelle,$br,$where=''){
		$_einst = array(
			'datensaetzteproquery' => 1000, # nach wieviel Datensaetzen soll ein neuer Query angefangen werden?
			'zeilenlaenge'         => 135   # wie lang soll eine Zeile sein duerfen?
		);
		$this->holeDaten('SHOW COLUMNS FROM '.$tabelle);
		$feldnamen = $feldtypen = array();
		$feldnamen = $this->baueArray('Field','#');
		$name2type = $this->baueArray('Type','Field');
		$queryanfang = 'INSERT INTO '.$tabelle.' ('.implode(',',$feldnamen).') VALUES '.$br;
		$query = 'SELECT '.implode(',',$feldnamen).' FROM '.$tabelle.(!empty($where)?' WHERE '.$where:'');
		$this->holeDaten($query);
		if($this->ergebnis['anzahl']==0){
			return '';
		}
		$daten = array();
		foreach($this->ergebnis['daten'] as $row){
			$tmp = array();
			$i = 0;

			foreach($row as $name => $spalte){
				if(is_null($spalte)){ # Wert ist NULL
					$tmp[] = 'NULL';
				}
				elseif($spalte === "" OR $spalte === false){ # Spalte ist leer
					$tmp[] = "''";
				}
				elseif(!ctype_digit($spalte) or (substr($name2type[$name],0,4)=='enum') or ($spalte{0}=='0' and strlen($spalte)>1)){
					# keine Zahl, enum-Feld oder Feldinhalt fängt mit 0 an -> in Anfuehrungszeichen und escapen
					$tmp[] = "'".mysqli_real_escape_string($this->db, $spalte)."'";
				}
				else{ # Zahl -> einfach uebernehmen
					$tmp[] = $spalte;
				}
				$i++;
			}
			$daten[] = '('.implode(',',$tmp).')';
		}
		$datensaetze = count($daten);
		$querys = $zeichen = 0;
		$tmp = $ausg = '';
		for($i=0;$i<$datensaetze;$i++){
			if($querys == 0){
				$tmp = $queryanfang;
			}
			$tmp .= $daten[$i];
			$querys++;
			$tmp .= ($i != $datensaetze-1 and $querys < $_einst['datensaetzteproquery'])?',':';';
			$zeichen += strlen($daten[$i])+2;
			if(isset($daten[$i+1]) and $zeichen+strlen($daten[$i+1])+1 >= $_einst['zeilenlaenge']){
				$tmp .= $br;
				$zeichen = 0;
			}
			else{
				$tmp .= ' ';
			}
			if($querys >= $_einst['datensaetzteproquery']){
				$ausg .= trim($tmp).$br;
				$tmp = '';
				$querys = $zeichen = 0;
			}
		}
		$ausg .= $tmp;
		return $ausg;
	}

	function baueArray($value,$key='#'){
		$a = array();
		if($this->ergebnis['anzahl'] == 0){
			return array();
		}
		if($key=='#'){
			if($value == '*'){
				return $this->ergebnis['daten'];
			}
			foreach($this->ergebnis['daten'] as $row){
				$a[] = $row[$value];
			}
		}
		else{
			foreach($this->ergebnis['daten'] as $row){
				$a[$row[$key]] = $value=='*'?$row:$row[$value];
			}
		}
		return $a;
	}

	function holeAnzahl(){
		return $this->ergebnis['anzahl'];
	}


	function holeZeile($zeile = 0){
		if($this->ergebnis['anzahl'] == 0 or !isset($this->ergebnis['daten'][$zeile])){
			return false;
		}
		return $this->ergebnis['daten'][$zeile];
	}


	function holeWert($spalte = NULL, $zeile = 0){
		/*
		Holt einen Wert aus der ersten Zeile des Ergebnisses, wenn $spalte angegeben
		ist, wird der Wert der angegebenene Spalte zurückgegeben, ansonsten der
		Wert der ersten Spalte. Wenn für $zeile eine Zahl größer 0 angegeben ist,
		wird der Wert der angegebenen Spalte zurückgegeben.
		Diese Methode ist dafür gedacht, um das Ergebnis von Querys die genau einen Wert
		liefern einfacher abfragen zu können.
		*/
		if($this->ergebnis['anzahl'] == 0 or !isset($this->ergebnis['daten'][$zeile])){
			return false;
		}
		if(is_null($spalte)){
			return current($this->ergebnis['daten'][$zeile]);
		}
		else{
			if(!isset($this->ergebnis['daten'][$zeile][$spalte]) and !is_null($this->ergebnis['daten'][$zeile][$spalte])){
				return false;
			}
			return $this->ergebnis['daten'][$zeile][$spalte];
		}
	}

	function holeInsertId(){
		if(isset($this->ergebnis['insertid'])){
			return $this->ergebnis['insertid'];
		}
		else{
			return false;
		}
	}

	function schliesseVerbindung(){
		mysqli_close($this->db);
		$this->db = '';
	}

	function leereErgebnis(){
		$this->ergebnis = array();
		return true;
	}

	function version(){
		$query = "SELECT VERSION() as v";
		$this->holeDaten($query);
		return $this->holeWert();
	}

	function setzeDbParameter($server='',$benutzername='',$passwort='',$datenbank=''){
		$v = true;
		$debug = debug_backtrace();
		$aufruf = array_pop($debug);
		# Server auswählen
		if(!empty($server)){
			$this->server = $server;
		}
		elseif(defined('DB_SERVER')){
			$this->server = DB_SERVER;
		}
		else{
			$v = false;
			$this->verarbeiteFehler('[kein Server angegeben]',E_USER_ERROR,$aufruf['file'],$aufruf['line']);
		}
		# Benutzername auswählen
		if(!empty($benutzername)){
			$this->benutzername = $benutzername;
		}
		elseif(defined('DB_BENUTZERNAME')){
			$this->benutzername = DB_BENUTZERNAME;
		}
		else{
			$v = false;
			$this->verarbeiteFehler('[keinen Benutzernamen angegeben]',E_USER_ERROR,$aufruf['file'],$aufruf['line']);
		}
		# Passwort auswählen
		if(!empty($passwort)){
			$this->passwort = $passwort;
		}
		elseif(defined('DB_PASSWORT')){
			$this->passwort = DB_PASSWORT;
		}
		else{
			$v = false;
			$this->verarbeiteFehler('[kein Passwort angegeben]',E_USER_WARNING,$aufruf['file'],$aufruf['line']);
		}
		# Datenbank auswählen
		if(!empty($datenbank)){
			$this->datenbank = $datenbank;
		}
		elseif(defined('DB_NAME')){
			$this->datenbank = DB_NAME;
		}
		else{
			$v = false;
			$this->verarbeiteFehler('[keine Datenbank angegeben]',E_USER_ERROR,$aufruf['file'],$aufruf['line']);
		}

		if($v){ $this->gesetzt = true; }
		return true;
	}

	function verbindeMitDb(){
		$debug = debug_backtrace();
		$aufruf = array_pop($debug);
		if(!$this->gesetzt){
			$this->verarbeiteFehler('[es sind keine Verbindungsdaten gesetzt]',E_USER_ERROR,$aufruf['file'],$aufruf['line']);
		}
		$_db = mysqli_connect($this->server,$this->benutzername,$this->passwort,$this->datenbank)
			or $this->verarbeiteFehler('[der Verbindungsversuch ist fehlgeschlagen]',E_USER_ERROR,$aufruf['file'],$aufruf['line']);
		$this->db = $_db;

		# Sprache der Ausgaben auf Deutsch setzen, Verbindung auf UTF8 setzen
		$query = "SET lc_time_names = 'de_DE'";
		mysqli_query($this->db, $query) or $this->verarbeiteFehler($query, E_USER_ERROR, 'DB-Klasse', __LINE__);
		mysqli_set_charset($this->db, 'utf8');
		return true;
	}

	function fuehreQueryAus($query,$fehlerart=E_USER_ERROR,$rueckmeldungstext=''){
		$debug = debug_backtrace();
		$aufruf = array_pop($debug);
		$zeile = empty($aufruf['line'])?'[unbekannt]':$aufruf['line'];
		$datei = empty($aufruf['file'])?$_SERVER['SCRIPT_NAME']:$aufruf['file'];
		if($this->schreibschutz and !isset($_SESSION['adminlogin'])){
			$this->verarbeiteFehler('[Schreibschutz gesetzt]',$fehlerart,$datei,$zeile);
			return;
		}
		$rs = mysqli_query($this->db,$query) or $this->verarbeiteFehler($query,$fehlerart,$aufruf['file'],$aufruf['line']);
		$this->anzahldbabfragen++;
		$rueckgabe = array();
		$rueckgabe['anzahl'] = mysqli_affected_rows($this->db);
		$rueckgabe['text'] = $rueckmeldungstext;

		$query = ltrim($query);
		$queryart = strtoupper(substr($query,0,strpos($query,' ')));
		if($queryart=='INSERT'){
			$rueckgabe['insertid'] = mysqli_insert_id($this->db);
		}
		
		# betroffene Tabelle als geaendert merken
		if($rueckgabe['anzahl'] > 0 and in_array($queryart, array('INSERT','UPDATE','DELETE','TRUNCATE','ALTER'))){
			$tabelle = '';
			switch($queryart){
			case 'INSERT':
				$tabellenregex = '~^INSERT\s*(?:LOW_PRIORITY|DELAYED|HIGH_PRIORITY)?\s*(?:IGNORE)?\s*(?:INTO)?\s*([a-z0-9_-]+)\s*~';
				break;
			case 'DELETE':
				$tabellenregex = '~^DELETE\s*(?:LOW_PRIORITY)?\s*(?:QUICK)?\s*(?:IGNORE)?\s*FROM\s*([a-z0-9_-]+)\s*~';
				break;
			case 'UPDATE':
				$tabellenregex = '~^UPDATE\s*(?:LOW_PRIORITY)?\s*(?:IGNORE)?\s*([a-z0-9_-]+)\s*SET~';
				break;
			case 'TRUNCATE':
				$tabellenregex = '~^TRUNCATE\s*(?:TABLE)?\s*([a-z0-9_-]+)\s*~';
				break;
			case 'ALTER':
				$tabellenregex = '~^ALTER\s*(?:IGNORE)?\s*TABLE\s*([a-z0-9_-]+)\s*~';
				break;
			}
			$anz = preg_match($tabellenregex,$query,$match);
			if($anz>0){
				$this->geaendertetabellen[] = $match[1];
			}
		}

		$this->ergebnis = $rueckgabe;
		return $rs;
	}


	function speichereGeaenderteTabellen(){
		if(count($this->geaendertetabellen) >= 1){
			$tabellen = array_unique($this->geaendertetabellen);
			$this->geaendertetabellen = array();
			$stand = parse_ini_file(PFAD_LOGDATEIEN.'dbaenderungen.ini',false);
			foreach($tabellen as $tabelle){
				if(!isset($stand[$tabelle])){
					$stand[$tabelle] = 1;
					ksort($stand);
					continue;
				}
				$stand[$tabelle] = 1;
			}
			require_once(PFAD_INCLUDE.'func/schreibe_ini_datei.inc.php');
			schreibe_ini_datei(PFAD_LOGDATEIEN.'dbaenderungen.ini',$stand,false);
		}

		if(false and TKSWIM_DEBUG and count($this->selectquerys) >= 1 and file_exists(PFAD_LOGDATEIEN.'querys.log') and is_writable(PFAD_LOGDATEIEN.'querys.log')){
			$fh = fopen(PFAD_LOGDATEIEN.'querys.log','a');
			foreach($this->selectquerys as $query){
				fwrite($fh,$query."\n",strlen($query."\n"));
			}
			fclose($fh);
		}
		return true;
	}

	function holeDaten($query,$fehlerart=E_USER_ERROR,$fetch='assoc'){
		$debug = debug_backtrace();
		$aufruf = array_pop($debug);
		$rs = mysqli_query($this->db, $query) or $this->verarbeiteFehler($query,$fehlerart,$aufruf['file'],$aufruf['line']);
		$this->anzahldbabfragen++;
		$erfolgreich = $rs?true:false;
		$erg = array();
		$anzahl = mysqli_num_rows($rs);
		switch($fetch){
			case 'row':
				while ($row = mysqli_fetch_row($rs)){ $erg[] = $row; }
				break;
			case 'array':
				while ($row = mysqli_fetch_array($rs)){ $erg[] = $row; }
				break;
			case 'assoc':
				while ($row = mysqli_fetch_assoc($rs)){ $erg[] = $row; }
				break;
			default:
				$this->verarbeiteFehler('[Ungueltiger 2. Paramter für holeDaten(), verwende »assoc«]',E_USER_NOTICE,$aufruf['file'],$aufruf['line']);
				while ($row = mysqli_fetch_assoc($rs)){ $erg[] = $row; }
				break;
		}
		if(TKSWIM_DEBUG){
			$query = preg_replace("/(\015\012)|(\015)|(\012)/",' ',$query);
			$query = preg_replace("/\s+/",' ',$query);
			$this->selectquerys[] = $query;
		}
		mysqli_free_result($rs);
		$this->ergebnis = array('daten' => $erg, 'anzahl' => $anzahl);
		return $erfolgreich;
	}

	function verarbeiteFehler($query,$fehlerart,$datei='',$zeile=''){
		$zeile = empty($zeile)?'[unbekannt]':$zeile;
		$datei = empty($datei)?$_SERVER['SCRIPT_NAME']:$datei;
		$inhalt = $datei.';'.$zeile.';';
		$inhalt .= preg_replace("/(\015\012)|(\015)|(\012)/",' ',str_replace(';',',',mysqli_error($this->db))).';';
		$inhalt .= preg_replace("/(\015\012)|(\015)|(\012)/",'[br]',str_replace(';','&#59;',$query));
		$inhalt = trim(preg_replace('/ +/',' ',$inhalt));
		trigger_error('[db] '.$inhalt,$fehlerart);
		return;
	}
}
#EOF
