<?php

class diagramme {

var $breite;
var $hoehe;
var $farben = array();
var $bild;
var $schriftgroesse = 10;
var $schriften = array();
var $achsen = array('x'=>array(),'y'=>array());
var $legende = array();
var $werte = array();


function __construct($breite, $hoehe){
	$this->breite = $breite;
	$this->hoehe = $hoehe;
	$im = imagecreate($breite, $hoehe);
	if($im === false){
		trigger_error('[tkswim] Das Bild konnte nicht erstellt werden.',E_USER_ERROR);
		return false;
	}
	else{
		$this->bild = $im;
		return $this->bild;
	}
}

function zeichneWerte($werte, $x, $y, $gruppe){
	$verschiebung_x = substr($this->achsen['x']['min'],-2);
	$verschiebung_y = $this->achsen['y']['min'];
	$farben = array(1=>'freistil',2=>'brust',3=>'ruecken',4=>'schmetterling',5=>'lagen');
	$letzterpunkt = array();
	foreach($werte as $row){
		$pos_x = $this->ursprung['x']+($this->achsen['x']['schritt_einheit']*($row[$x]+$verschiebung_x));
		$pos_y = $this->ursprung['y']-($this->achsen['y']['schritt_einheit']*($row[$y]-$verschiebung_y));
		$farbe = $farben[substr($row[$gruppe],0,1)];
		$this->setzePunkt($pos_x, $pos_y,5,$farbe);
		if(isset($letzterpunkt[$row[$gruppe]])){
			$alt = $letzterpunkt[$row[$gruppe]];
			imageline($this->bild, $alt['x'], $alt['y'], $pos_x, $pos_y, $this->farben[$farbe]);
		}
		$letzterpunkt[$row[$gruppe]] = array('x'=>$pos_x,'y'=>$pos_y);
		$this->werte[] = array('x'=>$pos_x,'y'=>$pos_y);
	}
	return count($werte);
}

function setzeLegende($farbe, $text){
	$this->legende[] = array('farbe' => $farbe, 'text' => $text);
	return true;
}

function _pruefeAufPunkte($x1, $y1, $x2, $y2, $abstand = 10){
	/*
	liefert false zurueck wenn sich im angegebenen Bereich Punkte befinden und
	true wenn keine vorhanden sind (x1/y1 ist die obere linke Ecke und x2/y2 die
	untere rechte Ecke)
	*/
	$anz = count($this->werte);
	for($i=0;$i<$anz;$i++){
		$w = $this->werte[$i];
		if($w['x'] >= ($x1-$abstand) and $w['x'] <= ($x2+$abstand) and $w['y'] >= ($y1-$abstand) and $w['y'] <= ($y2+$abstand)){
			return false;
		}
	}
	return true;
}

function zeichneLegende(){
	# Groesse ermitteln
	$breite = 35+($this->schriftgroesse*9);
	$hoehe = (count($this->legende)*($this->schriftgroesse+3))+5;
	# x und y Startwerte setzen und freie Stelle suchen
	$x = $this->ursprung['x']+10;
	$y = 10;
	$ok = $this->_pruefeAufPunkte($x, $y, $x+$breite, $y+$hoehe, 20);
	while(!$ok){
		$x += 10;
		if($x+$breite > $this->breite){
			$x = $this->ursprung['x']+10;
			$y += 10;
			if($y+$hoehe > $this->hoehe){
				$x = $this->ursprung['x']+10;
				$y = 10;
				break;
			}
		}
		$ok = $this->_pruefeAufPunkte($x, $y, $x+$breite, $y+$hoehe, 20);
	}
	# Hintergrund setzen (falls Linien durchlaufen) und Legende schreiben
	imagefilledrectangle($this->bild, $x, $y, $x+$breite, $y+$hoehe, $this->farben['hintergrund']);
	$text_x = $x+35;
	$text_y = $y+$this->schriftgroesse+3;
	foreach($this->legende as $legende){
		imageline($this->bild, $x+5, $text_y-($this->schriftgroesse/2), $x+30, $text_y-($this->schriftgroesse/2), $this->farben[$legende['farbe']]);
		$this->text($legende['text'], $text_x, $text_y);
		$text_y += $this->schriftgroesse+3;
	}
	return true;
}

function setzePunkt($pos_x, $pos_y, $durchmesser = 5, $farbe = 'linien'){
	if(!isset($this->farben[$farbe])){
		trigger_error('[tkswim][diagramme] Die Farbe ist ungültig.', E_USER_NOTICE);
		$farbe = 'linien';
	}
	imagefilledellipse($this->bild, $pos_x, $pos_y, $durchmesser, $durchmesser, $this->farben[$farbe]);
}

function zeichneAchsen(){
	# Postion der Achsen berechnen
	# y-Achse
	if($this->achsen['x']['art'] == 'datum'){
		$abstand_unten = 55;
	}
	$this->achsen['y']['laenge'] = $this->hoehe-$abstand_unten-10;
	$ursprung_y = $this->hoehe-$abstand_unten;
	# x-Achse
	if($this->achsen['y']['art'] == 'schwimmzeiten'){
		$abstand_links = 40;
	}
	$this->achsen['x']['laenge'] = $this->breite-$abstand_links-10;
	$ursprung_x = $abstand_links;

	# Ursprung setzen
	$this->setzeUrsprung($ursprung_x,$ursprung_y);

	# Schrittweite berechnen und Beschriftung zeichnen
	# x-Achse
	if($this->achsen['x']['art'] == 'datum'){
		$monate = 0;
		list($min_y,$min_m,) = explode('-',$this->achsen['x']['min']);
		$monate += 13-$min_m;
		list($max_y,$max_m,) = explode('-',$this->achsen['x']['max']);
		if($max_y > $min_y){
			$monate += $max_m;
			if($max_y > ($min_y+1)){ # mindestens noch ein Jahr zwischen $min und $max
				$monate += ($max_y-$min_y-1)*12;
			}
		}
		else{
			$monate -= 12-$max_m;
		}
		$this->achsen['x']['schritt'] = $this->achsen['x']['laenge']/$monate;
		$monateproschritt = 1;
		$schritt = $this->achsen['x']['schritt'];
		while($schritt < ($this->schriftgroesse*2.5)){
			$monateproschritt++;
			$schritt += $this->achsen['x']['schritt'];
		}
		$this->achsen['x']['schritt'] = $schritt;
		$this->achsen['x']['monateproschritt'] = $monateproschritt;
		$this->achsen['x']['schritt_einheit'] = ($schritt/$monateproschritt)/(365.25/12);
		# x-Achse selbst
		imageline($this->bild, $this->breite, $this->ursprung['y'], $this->ursprung['x'], $this->ursprung['y'], $this->farben['linien']);
		# Striche auf der Achse und Beschriftung
		$x = $this->ursprung['x']-30;
		$beschriftung = array('m' => $min_m, 'y' => $min_y);
		for($i=0;$i<=$monate;$i+=$this->achsen['x']['monateproschritt']){
			$monat = sprintf('%02d',$beschriftung['m']).'/'.$beschriftung['y'];
			$beschriftung['m'] += $this->achsen['x']['monateproschritt'];
			if($beschriftung['m'] > 12){
				$beschriftung['y'] += ceil(($beschriftung['m']-12)/12);
				$beschriftung['m'] = $beschriftung['m']%12;
				if($beschriftung['m'] == 0){
					$beschriftung['m'] = 12;
				}
			}
			$this->text($monat,$x,$this->hoehe-5,45);
			imageline($this->bild, $x+30, $this->ursprung['y']-5, $x+30, $this->ursprung['y']+5, $this->farben['linien']);
			$x += $this->achsen['x']['schritt'];
		}
	}

	# y-Achse
	if($this->achsen['y']['art'] == 'schwimmzeiten'){
		$min = $this->achsen['y']['min']/100;
		$max = $this->achsen['y']['max']/100;
		$sekunden = $max-$min;
		$sekundenproschritt = $sekunden<5?1:5;
		$this->achsen['y']['schritt'] = $this->achsen['y']['laenge']/($sekunden/$sekundenproschritt);
		$schritt = $this->achsen['y']['schritt'];
		while($schritt < ($this->schriftgroesse*2)){
			$sekundenproschritt += $sekunden<5?1:5;
			$schritt += $this->achsen['y']['schritt'];
		}
		$this->achsen['y']['schritt'] = $schritt;
		$this->achsen['y']['sekundenproschritt'] = $sekundenproschritt;
		$this->achsen['y']['schritt_einheit'] = ($schritt/$sekundenproschritt)/100;
		# y-Achse selbst
		imageline($this->bild, $this->ursprung['x'], 0, $this->ursprung['x'], $this->ursprung['y'], $this->farben['linien']);
		# Striche auf der Achse und Beschriftung
		$verschiebung = $this->schriftgroesse/2.5; # Verschiebung der Beschriftung gegenüber dem Ursprung
		$y = $this->ursprung['y']+$verschiebung;
		$x = $this->ursprung['x']; # fuer kleine Linien
		for($i=(int)($min*100);$i<=$max*100;$i+=($this->achsen['y']['sekundenproschritt']*100)){
			$this->text(substr(text_format($i,'schwimmzeit',false),1,-3),5, $y,0);
			imageline($this->bild,$x-5, $y-$verschiebung, $x+5, $y-$verschiebung, $this->farben['linien']);
			$y -= $this->achsen['y']['schritt'];
		}
	}
}

function setzeUrsprung($x, $y){
	$this->ursprung = array('x'=>$x,'y'=>$y);
}

function setzeAchse($xy, $art, $min, $max, $optionen = null){
	if($xy == 'y'){
		if($art == 'schwimmzeiten'){
			$this->achsen['y'] = array(
				'art' => 'schwimmzeiten',
				'min' => floor($min/100)*100,
				'max' => ceil($max/100)*100
			);
			if($this->achsen['y']['min']%500 != 0){
				$this->achsen['y']['min'] -= $this->achsen['y']['min']%500;
			}
		}

	}

	if($xy == 'x'){
		if($art == 'datum'){
			$this->achsen['x'] = array(
				'art' => 'datum',
				'min' => $min,
				'max' => $max
			);
		}
	}
	return true;
}

function text($text, $pos_x, $pos_y, $winkel = 0, $schriftgroesse = 0, $farbe = 'schrift', $schriftart = 0){
	if(!isset($this->farben[$farbe])){
		trigger_error('[tkswim][diagramme] Die Farbe ist ungültig.', E_USER_NOTICE);
		$farbe = 'schrift';
	}
	if(!isset($this->schriften[$schriftart])){
		trigger_error('[tkswim][diagramme] Die Schriftart ist ungültig.', E_USER_NOTICE);
		$schriftart = 0;
	}
	if($schriftgroesse == 0){
		$schriftgroesse = $this->schriftgroesse;
	}
	return imagettftext($this->bild, $schriftgroesse, $winkel, $pos_x, $pos_y, $this->farben[$farbe], $this->schriften[$schriftart], $text);
}

function setzeSchrift($pfad){
	$this->schriften[] = $pfad;
	return array_search($pfad, $this->schriften);
}

function setzeFarbe($type, $rot, $gruen, $blau){
	$farbe = imagecolorallocate($this->bild, $rot, $gruen, $blau);
	$this->farben[$type] = $farbe;
}

function gebeDiagrammAus($rueckgabe = false){
	if($rueckgabe){
		ob_start();
		imagepng($this->bild);
		$bild = ob_get_clean();
		imagedestroy($this->bild);
		return $bild;
	}
	else{
		header("Content-type: image/png");
		imagepng($this->bild);
		imagedestroy($this->bild);
		exit;
	}
}

} # Ende der Klasse, EOF
