<?php
class einstellungen{

var $einstdatei;   # Name (mit Pfad) der xml/php-Datei mit den Einstellungen
var $userconfpfad; # Pfad in dem die Dateien mit den Usereinstellungen liegen
var $userdatei;    # Dateiname der Einstellungen des aktuellen Users
var $globaldatei;  # Dateiname (mit Pfad) der Datei mit den globalen Einstellungen
var $_db;          # Datenbankklasse

function __construct($art, $user = false){
	$this->einstdatei = PFAD_INCLUDE.'conf/'.($art=='global'?'einstellungen-ini.php':'user-ini.php');
	$this->userconfpfad = PFAD_INIDATEIEN;
	if($art == 'user'){
		$this->userdatei = 'userconf_'.$user.'.ini';
	}
	$this->globaldatei = PFAD_INCLUDE.'conf/einstellungen.ini';
}

function benachrichtigungLoeschen($id, $art){
/*
Parameter:
 $id:  die ID der zu entfernenden Benachrichtigungen
 $art: die Art der zu entfernenden Benachrichtigung
Rueckgabewerte:
true: Wert geloescht
 -1:   ungueltige ID angegeben
 -2:   ungueltige Art angegeben
 -3:   Benachrichtigung war nicht vorhanden
*/
	if(is_array($id) and count($id) > 0){
		foreach($id as $i){
			if(empty($i) or !ctype_digit($i)){
				continue;
			}
			$this->benachrichtigungLoeschen($i,$art);
		}
	}
	switch($art){
	case 'person':
		if(empty($id) or !ctype_digit($id)){
			return -1;
		}
		$query = "SELECT id FROM ".DB_PREFIX."mitglieder WHERE id = '".text_format($id,'db')."'";
		$this->db->holeDaten($query);
		if($this->db->ergebnis['anzahl'] != 1){
			return -1;
		}
		$datinh = parse_ini_file($this->userconfpfad.$this->userdatei,true);
		list($termine, $gruppen, $personen) = explode('|',$datinh['emailbenachrichtigung']['terminbenachrichtigungen'],3);
		list(,$pids) = explode(':',$personen);
		if(empty($pids)){
			return -3;
		}
		else{
			$ids = explode(',',$pids);
			if(!in_array($id,$ids)){
				return -3;
			}
			$tmp = $ids;
			$ids = array();
			foreach($tmp as $i){
				if($i == $id){
					continue;
				}
				$ids[] = $i;
			}
			$pids = implode(',',$ids);
		}require($this->einstdatei);
		$datinh['emailbenachrichtigung']['terminbenachrichtigungen'] = $termine.'|'.$gruppen.'|personen:'.$pids;
		require_once(PFAD_INCLUDE.'func/schreibe_ini_datei.inc.php');
		schreibe_ini_datei($this->userconfpfad.$this->userdatei,$datinh,true);
		$this->cronjobEinstellungenEinlesen();
		return true;
	case 'gruppe':
		require_once(PFAD_INCLUDE.'func/holegruppen.inc.php');
		$erlaubte = array_keys(holeGruppen());
		$erlaubte[] = 'uebungsleiter';
		$erlaubte[] = 'kampfrichter';
		$erlaubte[] = 'vorstand';
		if(empty($id) or !in_array($id, $erlaubte)){
			return -1;
		}
		if(!in_array($id,$erlaubte)){
			return -1;
		}
		$datinh = parse_ini_file($this->userconfpfad.$this->userdatei,true);
		list($termine, $gruppen, $personen) = explode('|',$datinh['emailbenachrichtigung']['terminbenachrichtigungen'],3);
		list(,$gids) = explode(':',$gruppen);
		if(empty($gids)){
			return -3;
		}
		else{
			$ids = explode(',',$gids);
			if(!in_array($id,$ids)){
				return -3;
			}
			$tmp = $ids;
			$ids = array();
			foreach($tmp as $i){
				if($i == $id){
					continue;
				}
				$ids[] = $i;
			}
			$gids = implode(',',$ids);
		}
		$datinh['emailbenachrichtigung']['terminbenachrichtigungen'] = $termine.'|gruppen:'.$gids.'|'.$personen;
		require_once(PFAD_INCLUDE.'func/schreibe_ini_datei.inc.php');
		schreibe_ini_datei($this->userconfpfad.$this->userdatei,$datinh,true);
		$this->cronjobEinstellungenEinlesen();
		return true;
		break;
	case 'termin':
		if(empty($id) or !ctype_digit($id)){
			return -1;
		}
		$query = "SELECT id FROM ".DB_PREFIX."termine WHERE id = '".text_format($id,'db')."'";
		$this->db->holeDaten($query);
		if($this->db->ergebnis['anzahl'] != 1){
			return -1;
		}
		$datinh = parse_ini_file($this->userconfpfad.$this->userdatei,true);
		list($termine, $gruppen, $personen) = explode('|',$datinh['emailbenachrichtigung']['terminbenachrichtigungen'],3);
		list(,$tids) = explode(':',$termine);
		if(empty($tids)){
			return -3;
		}
		else{
			$ids = explode(',',$tids);
			if(!in_array($id,$ids)){
				return -3;
			}
			$tmp = $ids;
			$ids = array();
			foreach($tmp as $i){
				if($i == $id){
					continue;
				}
				$ids[] = $i;
			}
			$tids = implode(',',$ids);
		}
		$datinh['emailbenachrichtigung']['terminbenachrichtigungen'] = 'termine:'.$tids.'|'.$gruppen.'|'.$personen;
		require_once(PFAD_INCLUDE.'func/schreibe_ini_datei.inc.php');
		schreibe_ini_datei($this->userconfpfad.$this->userdatei,$datinh,true);
		$this->cronjobEinstellungenEinlesen();
		return true;
	default:
		return -2;
	}
}

function benachrichtigungHinzufuegen($id, $art){
/*
Parameter:
 $id:  die ID der hinzuzufuegenden Benachrichtigungen
 $art: die Art der hinzuzufuegenden Benachrichtigung
Rueckgabewerte:
 true: Wert gespeichert
 -1:   ungueltige ID angegeben
 -2:   ungueltige Art angegeben
 -3:   Benachrichtigung war bereits vorhanden
*/
	switch($art){
	case 'person':
		if(empty($id) or !ctype_digit($id)){
			return -1;
		}
		$query = "SELECT id FROM ".DB_PREFIX."mitglieder WHERE id = '".text_format($id,'db')."'";
		$this->db->holeDaten($query);
		if($this->db->ergebnis['anzahl'] != 1){
			return -1;
		}
		$datinh = parse_ini_file($this->userconfpfad.$this->userdatei,true);
		list($termine, $gruppen, $personen) = explode('|',$datinh['emailbenachrichtigung']['terminbenachrichtigungen'],3);
		list(,$pids) = explode(':',$personen);
		if(empty($pids)){
			$pids = $id;
		}
		else{
			$ids = explode(',',$pids);
			if(in_array($id,$ids)){
				return -3;
			}
			$pids .= ','.$id;
		}
		$datinh['emailbenachrichtigung']['terminbenachrichtigungen'] = $termine.'|'.$gruppen.'|personen:'.$pids;
		require_once(PFAD_INCLUDE.'func/schreibe_ini_datei.inc.php');
		schreibe_ini_datei($this->userconfpfad.$this->userdatei,$datinh,true);
		$this->cronjobEinstellungenEinlesen();
		return true;
	case 'gruppe':
		if(!is_array($id)){
			return -1;
		}
		$datinh = parse_ini_file($this->userconfpfad.$this->userdatei,true);
		list($termine, $gruppen, $personen) = explode('|',$datinh['emailbenachrichtigung']['terminbenachrichtigungen'],3);
		$datinh['emailbenachrichtigung']['terminbenachrichtigungen'] = $termine.'|gruppen:'.implode(',',$id).'|'.$personen;
		require_once(PFAD_INCLUDE.'func/schreibe_ini_datei.inc.php');
		schreibe_ini_datei($this->userconfpfad.$this->userdatei,$datinh,true);
		$this->cronjobEinstellungenEinlesen();
		return true;
		break;
	case 'termin':
		if(empty($id) or !ctype_digit($id)){
			return -1;
		}
		$query = "SELECT id FROM ".DB_PREFIX."termine WHERE id = '".text_format($id,'db')."'";
		$this->db->holeDaten($query);
		if($this->db->ergebnis['anzahl'] != 1){
			return -1;
		}
		$datinh = parse_ini_file($this->userconfpfad.$this->userdatei,true);
		list($termine, $gruppen, $personen) = explode('|',$datinh['emailbenachrichtigung']['terminbenachrichtigungen'],3);
		list(,$tids) = explode(':',$termine);
		if(empty($tids)){
			$tids = $id;
		}
		else{
			$ids = explode(',',$tids);
			if(in_array($id,$ids)){
				return -3;
			}
			$tids .= ','.$id;
		}
		$datinh['emailbenachrichtigung']['terminbenachrichtigungen'] = 'termine:'.$tids.'|'.$gruppen.'|'.$personen;
		require_once(PFAD_INCLUDE.'func/schreibe_ini_datei.inc.php');
		schreibe_ini_datei($this->userconfpfad.$this->userdatei,$datinh,true);
		$this->cronjobEinstellungenEinlesen();
		return true;
	default:
		return -2;
	}
}

function holeBenachrichtigungen(){
	$einst = parse_ini_file($this->userconfpfad.$this->userdatei,true);
	list($termine, $gruppen, $personen) = explode('|',$einst['emailbenachrichtigung']['terminbenachrichtigungen'],3);
	$rueckgabe = array('termine'=>array(),'gruppen'=>array(),'personen'=>array());
	# Termine holen
	list(,$ids) = explode(':',$termine);
	if(!empty($ids)){
		$query = "SELECT id, CONCAT(DATE_FORMAT(datum,'%d.%m.%Y'),': ',titel) as titel FROM ".DB_PREFIX."termine WHERE id IN (".$ids.") ORDER BY datum";
		$this->db->holeDaten($query);
		$rueckgabe['termine'] = $this->db->baueArray('titel','id');
	}
	# Gruppen holen
	list(,$ids) = explode(':',$gruppen);
	if(!empty($ids)){
		$teile = explode(',',$ids);
		$ids = array();
		$uebungsleiter = $kampfrichter = $vorstand = false;
		foreach($teile as $teil){
			if($teil == 'uebungsleiter'){
				$uebungsleiter = true;
			}
			elseif($teil == 'kampfrichter'){
				$kampfrichter = true;
			}
			elseif($teil == 'vorstand'){
				$vorstand = true;
			}
			else{
				$ids[] = $teil;
			}
		}
		if(count($ids)>0){
			$query = "SELECT id, bezeichnung FROM ".DB_PREFIX."gruppen WHERE id IN (".implode(',',$ids).") ORDER BY sort";
			$this->db->holeDaten($query);
			$rueckgabe['gruppen'] = $this->db->baueArray('bezeichnung', 'id');
		}
		if($vorstand){
			$rueckgabe['gruppen']['vorstand'] = 'Vorstand';
		}
		if($uebungsleiter){
			$rueckgabe['gruppen']['uebungsleiter'] = 'Übungsleiter';
		}
		if($kampfrichter){
			$rueckgabe['gruppen']['kampfrichter'] = 'Kampfrichter';
		}
	}
	# Personen holen
	list(,$ids) = explode(':',$personen);
	if(!empty($ids)){
		$query = "SELECT id, CONCAT(nachname,', ',vorname,' (',DATE_FORMAT(gebdatum,'%d.%m.%Y'),')') as name
					FROM ".DB_PREFIX."mitglieder WHERE id IN (".$ids.") ORDER BY nachname, vorname";
		$this->db->holeDaten($query);
		$rueckgabe['personen'] = $this->db->baueArray('name','id');
	}
	return $rueckgabe;
}

function cronjobEinstellungenEinlesen(){
	$datinh = parse_ini_file(PFAD_INCLUDE.'conf/cronjob.ini',true);
	if($datinh['flags']['userconfeinlesen'] == 1){
		return true;
	}
	$datinh['flags']['userconfeinlesen'] = 1;
	require_once(PFAD_INCLUDE.'func/schreibe_ini_datei.inc.php');
	schreibe_ini_datei(PFAD_INCLUDE.'conf/cronjob.ini',$datinh,true);
	return true;
}

function aktualisiereGlobalIniDatei(){
	# Einstellungen laden
	require($this->einstdatei);

	# vorhandene ini-Datei einlesen
	$vorhandene = parse_ini_file($this->globaldatei, true);

	$geaendert = false;
	# prüfen ob neue Einstellungen vorhanden sind
	foreach($_einstellungen as $modul => $tmp){
		if(!isset($vorhandene[$modul])){
			$vorhandene[$modul] = array();
			$geaendert = true;
		}
		foreach($tmp as $einst => $werte){
			if(!isset($vorhandene[$modul][$einst])){
				$vorhandene[$modul][$einst] = $werte['standard'];
				$geaendert = true;
			}
		}
	}

	# prüfen ob Einstellungen gelöscht wurden
	foreach($vorhandene as $modul => $tmp){
		if(!isset($_einstellungen[$modul])){
			unset($vorhandene[$modul]);
			$geaendert = true;
		}
		foreach($tmp as $einst => $werte){
			if(!isset($_einstellungen[$modul][$einst])){
				unset($vorhandene[$modul][$einst]);
				$geaendert = true;
			}
		}
	}

	# ggf. geänderte ini-Datei schreiben
	if($geaendert){
		require_once(PFAD_INCLUDE.'func/schreibe_ini_datei.inc.php');
		schreibe_ini_datei($this->globaldatei, $vorhandene, true);
	}
	return true;
}

function aktualisiereUserinidateien(){
	require($this->einstdatei);
	$neu = array();
	foreach($_usereinstellungen as $mid => $optionen){
		if(isset($neu[$mid])){
			$neu[$mid] = array();
		}
		foreach($optionen as $oid => $option){
			$neu[$mid][$oid] = $option['standard'];
		}
	}
	
	$dh = opendir($this->userconfpfad);
	$dateien = array();
	while(false !== ($file = readdir($dh))){
		if($file == '.' or $file == '..' or substr($file,0,9) != 'userconf_' or is_dir($file) or substr($file,-4) != '.ini'){
			continue;
		}
		$dateien[] = $file;
	}
	closedir($dh);
	require_once(PFAD_INCLUDE.'func/schreibe_ini_datei.inc.php');
	foreach($dateien as $datei){
		$datinh = parse_ini_file($this->userconfpfad.$datei,true);
		$datinh_neu = $neu;
		foreach($datinh_neu as $mid => $modul){
			if(!isset($datinh[$mid])){
				continue;
			}
			foreach($modul as $oid => $option){
				if(isset($datinh[$mid][$oid])){
					$datinh_neu[$mid][$oid] = $datinh[$mid][$oid];
				}
			}
		}
		schreibe_ini_datei($this->userconfpfad.$datei,$datinh_neu,true);
	}
	# Cronjob sagen, dass Usereinstellungen neu eingelesen werden muessen
	$this->cronjobEinstellungenEinlesen();
	return true;
}

} # Ende der Klasse, EOF
?>