<?php

class kalender{

var $monat;
var $jahr;
var $conf;
var $tmpl;
var $db;

function __construct($monat='',$jahr=''){
	$this->setzeMonat($monat);
	$this->setzeJahr($jahr);
}

function istTraining($datum){
	/*
	liefert true oder false, je nach dem ob an dem angegebenen Datum
	(im Format: DD.MM.YYYY) Training war oder nicht
	*/
	list($tag,$monat,$jahr) = explode('.',$datum,3);
	# pruefen ob Datum in den Ferien liegt
	$ferientage = $this->holeFerientage($monat,$jahr);
	$ferien = in_array($tag, $ferientage['ferientage']);
	# pruefen ob an dem Tag des Datums Training ist
	$query = "SELECT DISTINCT wochentag FROM ".DB_PREFIX."trainingszeiten".($ferien?" WHERE inferien = 1":"");
	$this->db->holeDaten($query);
	$trainingstage = $this->db->baueArray('wochentag','#');
	$wochentag = date('w',mktime(12,0,0,$monat,$tag,$jahr));
	if($wochentag == 0){ # date('w') liefert bei Sontag eine 0, in der Datenbank wuerde aber eine 7 stehen
		$wochentag = 7;
	}
	if(!in_array($wochentag, $trainingstage)){
		return false;
	}
	# an dem Tag ist Training
	return true;
}

function legeFeiertageAn($daten){
	# vorhandene Ferien holen
	$query = "SELECT CONCAT(art,'_',jahr,'_',nr) as teststring, DATE_FORMAT(von, '%d.%m.%Y') as v, DATE_FORMAT(bis,'%d.%m.%Y') as b
				FROM ".DB_PREFIX."ferien
				WHERE von < FROM_UNIXTIME(".$daten['flags']['zeitraum_ende'].") AND
				((bis IS NULL AND von > FROM_UNIXTIME(".$daten['flags']['zeitraum_anfang'].")) OR
					bis > FROM_UNIXTIME(".$daten['flags']['zeitraum_anfang']."))
				ORDER BY von, bis";
	$this->db->holeDaten($query);
	$vorhandene_test = $this->db->baueArray('teststring','teststring');
	$vorhandene_alles = $this->db->baueArray('*','teststring');
	$korrigierte = 0;
	$anzulegende = $zuaendernde = array();
	foreach($daten['ferien'] as $row){
		$key = $row['art'].'_'.$row['jahr'].'_'.$row['nr'];
		# prüfen ob Ferien vorhanden
		if(in_array($key, $vorhandene_test)){
			# prüfen ob gespeicherte Werte korrekt sind
			if($row['von'] != $vorhandene_alles[$key]['v'] or $row['bis'] != $vorhandene_alles[$key]['b']){
				$query = "UPDATE ".DB_PREFIX."ferien
							SET von = '".text_format($row['von'], 'dbdatum')."',
								bis  = ".(is_null($row['bis'])?'NULL':"'".text_format($row['bis'],'dbdatum')."'")."
							WHERE art = ".$row['art']." AND jahr = ".$row['jahr']." AND nr = ".$row['nr']."";
				$this->db->fuehreQueryAus($query);
				$korrigierte++;
			}
		}
		else{
			$anzulegende[] = $row;
		}
	}
	$anz = 0;
	if(count($anzulegende) > 0){
		# alte Kalendereinträge ermitteln
		$query = "SELECT art, jahr, nr FROM ".DB_PREFIX."ferien WHERE
				(bis IS NULL AND von < FROM_UNIXTIME(".$daten['flags']['zeitraum_anfang'].")) OR
				(bis IS NOT NULL AND bis < FROM_UNIXTIME(".$daten['flags']['zeitraum_anfang']."))";
		$this->db->holeDaten($query);
		if($this->db->holeAnzahl()>0){
			$verwenden = $this->db->baueArray('*','#');
		}
		else{
			$verwenden = array();
		}

		# bereits verwendete Bezeichnungen der Ferien holen
		$query = "SELECT DISTINCT art, bezeichnung FROM ".DB_PREFIX."ferien";
		$this->db->holeDaten($query);
		$bezeichnungen = $this->db->baueArray('bezeichnung', 'art');
		$bezeichnungen_original = $daten['texte'];

		# Querys zum Schreiben der neuen Feiertage generieren
		$querys = array();
		foreach($anzulegende as $row){
			if(isset($bezeichnungen[$row['art']])){
				$bezeichnung = $bezeichnungen[$row['art']];
			}
			elseif(isset($bezeichnungen_original[$row['art']])){
				$bezeichnung = $bezeichnungen_original[$row['art']];
			}
			else{ # Absicherung falls wider Erwarten doch was schiefgehen sollte
				$bezeichnung = 'Ferien';
			}

			if(count($verwenden)>0){
				$recycle = array_shift($verwenden);
				$querys[] = "UPDATE ".DB_PREFIX."ferien
							SET art  = '".text_format($row['art'],'db')."',
								jahr = '".text_format($row['jahr'],'db')."',
								nr   = '".text_format($row['nr'],'db')."',
								von  = '".text_format($row['von'],'dbdatum')."',
								bis  = ".(is_null($row['bis'])?'NULL':"'".text_format($row['bis'],'dbdatum')."'").",
								bezeichnung = '".text_format($bezeichnung,'db')."'
							WHERE art = ".$recycle['art']." AND jahr = ".$recycle['jahr']." AND nr = ".$recycle['nr']."";
			}
			else{
				$querys[] = "INSERT INTO ".DB_PREFIX."ferien
							SET art  = '".text_format($row['art'],'db')."',
								jahr = '".text_format($row['jahr'],'db')."',
								nr   = '".text_format($row['nr'],'db')."',
								von  = '".text_format($row['von'],'dbdatum')."',
								bis  = ".(is_null($row['bis'])?'NULL':"'".text_format($row['bis'],'dbdatum')."'").",
								bezeichnung = '".text_format($bezeichnung,'db')."'";
			}
		}
		# Querys ausfuehren und Meldung schreiben
		$anz = count($querys);
		for($i=0;$i<$anz;$i++){
			$this->db->fuehreQueryAus($querys[$i]);
		}
		$this->db->speichereGeaenderteTabellen();
	}
	return array('angelegt' => $anz, 'korrigiert'=>$korrigierte);

}


function holeFerientermine(){
	$url = 'https://tkswim.de/daten.php?inhalt=ferien&version='.TKSWIM_VERSION.'&lsv='.TKSWIM_LSVKENNZIFFER;
	if(ini_get('allow_url_fopen') != 1){
		return 'Die Ferien-Daten konnten nicht abgerufen werden.';
	}
	$xml_parser = xml_parser_create();
	xml_set_object($xml_parser,$this);
	xml_set_element_handler($xml_parser, '_startelement', '_endelement');
	$fh = fopen($url, 'r');
	if($fh === false){
		die('could not open XML input');
	}
	while($data = fread($fh, 4096)){
		if(!xml_parse($xml_parser, $data, feof($fh))){
			return sprintf("XML error: %s at line %d",
			xml_error_string(xml_get_error_code($xml_parser)),
			xml_get_current_line_number($xml_parser));
		}
	}
	fclose($fh);
	xml_parser_free($xml_parser);

	if(isset($this->daten['fehler'])){
		return $this->daten['fehler'];
	}

	if(version_compare($this->daten['flags']['xmlversion'], '2.0', '<')){
		return 'Die XML-Version der Daten wird nicht mehr unterstützt, bitte wenden sie sich an den Hersteller von tkswim.';
	}

	foreach($this->daten['texte'] as $id => $text){
		$this->daten['texte'][$id] = trim($text);
	}
	return $this->daten;
}

function _startelement($parser, $name, $attrs){
	$name = strtolower($name);
	$this->_speicher['element'] = $name;
	switch($name){
	case 'fehler':
		$this->daten['fehler'] = $attrs['TEXT'];
		break;
	case 'ferientermine':
		$this->daten = array();
		$this->daten['flags'] = array();
		$this->daten['texte'] = array();
		$this->daten['ferien'] = array();
		break;
	case 'flag':
		$this->daten['flags'][$attrs['VAR']] = $attrs['WERT'];
		break;
	case 'text':
		$this->daten['texte'][$attrs['ID']] = $attrs['BEZEICHNUNG'];
		break;
	case 'ferien':
		if(!isset($attrs['ART'])){
			break;
		}
		$this->daten['ferien'][] = array(
			'art'  => $attrs['ART'],
			'jahr' => $attrs['JAHR'],
			'nr'   => $attrs['NR'],
			'von'  => $attrs['VON'],
			'bis'  => isset($attrs['BIS'])?$attrs['BIS']:NULL
		);
		break;
	default:
		break;
	}
}

function _endelement($parser,$name){
# dummy-Methode da eine Methode für die End-Elemente vorhanden sein muss
}

function holeMonat(){
	# Navigationsleiste
	$this->tmpl->assign('conf',$this->conf);
	$this->tmpl->assign('monat',$this->monat);
	$this->tmpl->assign('jahr',$this->jahr);
	$this->tmpl->assign('v',$this->_berechneVorherigenMonat());
	$this->tmpl->assign('n',$this->_berechneNaechstenMonat());

	# Daten einsammeln
	$query = "SELECT id, DATE_FORMAT(datum,'%e') as tag, titel, DATE_FORMAT(datum,'%H:%i') as zeit
				FROM ".DB_PREFIX."termine
				WHERE DATE_FORMAT(datum,'%c%Y') = ".$this->monat.$this->jahr."
				ORDER BY datum";
	$this->db->holeDaten($query);
	$tage = $this->db->baueArray('tag','#');
	$daten_termine = $this->db->ergebnis['daten'];
	$wochentag_erster = date('w',mktime(3,0,0,$this->monat,1,$this->jahr));
	$anzahl_tage = date('t',mktime(3,0,0,$this->monat,1,$this->jahr));
	$wochentag_letzter = date('w',mktime(3,0,0,$this->monat,$anzahl_tage,$this->jahr));
	$tmp = $this->holeFerientage();
	$ferien = $tmp['ferientage'];

	# Tabelleninhalt
	$daten = '<tr>'."\n";
	$daten .= str_repeat('<td></td>'."\n",($wochentag_erster==0?6:($wochentag_erster-1)));
	$qs = 'monat='.$this->monat.'&amp;jahr='.$this->jahr;
	if($this->monat == date('n') AND $this->jahr == date('Y')){
		$aktuell = date('j');
	}
	else{
		$aktuell = 0;
	}
	for($i=1;$i<=$anzahl_tage;$i++){
		$daten .= ' <td';
		$klassen = array();
		if((($i+($wochentag_erster-1))%7 == 0) or (($i+($wochentag_erster-1))%7 == 6)){
			$klassen[] = 'wochenende';
		}
		if(in_array($i,$ferien)){
			$klassen[] = 'ferien';
		}
		if($i == $aktuell){
			$klassen[] = 'aktuell';
		}
		if(count($klassen) != 0){
			$daten .= ' class="'.implode(' ',$klassen).'"';
		}
		$daten .= '><strong><a href="'.ROOT.'/sonstiges/kalender'.TKSWIM_DATEIENDUNG.'?tag='.$i.'&amp;'.$qs.'">'.$i.'</a></strong><br />';
		if(in_array($i,$tage)){
			foreach($daten_termine as $row){
				if($row['tag'] == $i){
					$daten .= ($row['zeit']!='00:00'?$row['zeit'].': ':'').$row['titel'].'<br />';
				}
			}
		}
		$daten .= '</td>'."\n";
		if((($i+($wochentag_erster-1))%7 == 0) AND $i != $anzahl_tage){
			$timestamp = mktime(12,0,0,$this->monat,$i-1,$this->jahr);
			$daten .= '<td>'.date('W',$timestamp).'</td></tr>'."\n".'<tr>'."\n";
		}
	}
	if($wochentag_letzter != 0){
		$daten .= str_repeat('<td></td>'."\n",7-$wochentag_letzter);
	}
	# fuer Wochennummer
	$timestamp = mktime(12,0,0,$this->monat,$i-1,$this->jahr);
	$daten .= '<td>'.date('W',$timestamp).'</td></tr>'."\n";
	$this->tmpl->assign('kalenderinhalt',$daten);
	return $this->tmpl->fetch('sonstiges/61.kalender-index.inc.html');
}

function holeTag($tag){
	$this->tmpl->assign('datum', sprintf('%02d.%02d.%04d',$tag,$this->monat,$this->jahr));
	$this->tmpl->assign('tag',$tag);
	$this->tmpl->assign('monat',$this->monat);
	$this->tmpl->assign('jahr',$this->jahr);
	$this->tmpl->assign('alletermine', $this->conf['_einst']['emailbenachrichtigung']['analletermineerinnern']);

	$query = "SELECT id, DATE_FORMAT(datum,'%H:%i') as zeit, titel, was FROM ".DB_PREFIX."termine WHERE
				DATE_FORMAT(datum,'%Y-%m-%d') = '".sprintf('%04d-%02d-%02d',$this->jahr,$this->monat,$tag)."'
				ORDER BY datum";
	$this->db->holeDaten($query);
	$termindaten = $this->db->ergebnis['daten'];
	global $_einst, $_gleinst;
	list($termine,,) = explode('|',$_einst['emailbenachrichtigung']['terminbenachrichtigungen'],3);
	list(,$termine) = explode(':',$termine);
	if(!empty($termine)){
		$termine = explode(',',$termine);
		foreach($termindaten as $key => $row){
			if(!in_array($row['id'],$termine)){
				continue;
			}
			$termindaten[$key]['benachrichtigen'] = 1;
		}
	}
	$this->tmpl->assign('termine',$termindaten);
	$query = "SELECT id, CONCAT(vorname,' ',nachname) as name, YEAR(gebdatum) as jahrg, ".$this->jahr."-YEAR(gebdatum) as alt
				FROM ".DB_PREFIX."mitglieder
				WHERE ausgetreten IS NULL AND
				DATE_FORMAT(gebdatum,'%m-%d') = '".sprintf('%02d-%02d',$this->monat,$tag)."'
				ORDER BY nachname";
	$this->db->holeDaten($query);
	$this->tmpl->assign('geburtstage',$this->db->baueArray('*','#'));
	$tmp = $this->holeFerientage();
	if(in_array($tag,array_keys($tmp['tage_ferienid']))){
		$query = "SELECT IF(YEAR(von)=YEAR(bis),IF(MONTH(von)=MONTH(bis),DATE_FORMAT(von,'%e.'),DATE_FORMAT(von,'%e. %M')),DATE_FORMAT(von,'%e. %M %Y')) as v,
					DATE_FORMAT(bis,'%e. %M %Y') as b, bezeichnung
					FROM ".DB_PREFIX."ferien
					WHERE CONCAT(art,'_',jahr,'_',nr) IN ('".str_replace(' ',"','",$tmp['tage_ferienid'][(int)$tag])."')
					ORDER BY von, bis";
		$this->db->holeDaten($query);
		$this->tmpl->assign('ferien',$this->db->baueArray('*','#'));
	}
	$this->tmpl->tk_javascriptzuweisen('dateien', 'jquery,jquery.message,jquery.ui,jquery.tkswim');
	$this->tmpl->tk_javascriptzuweisen('onready', "\$('.loeschen').tkswim_loeschfrage({art:'termine',frage:'Soll der Termin wirklich gelöscht werden?',elternelement:'p'});");
	$rueckgabe = $this->tmpl->fetch('sonstiges/61.kalender-tag.inc.html');
	return $rueckgabe;
}

function holeTrainingstage($wochentag, $von, $bis=''){
	if($wochentag < 0 or $wochentag > 7){
		die('falscher Aufruf der Methode ($wochentag ist ungültig).');
	}
	# Parameter importieren
	list($_von_monat,$_von_jahr) = preg_split('~[^\d]+~',$von,2);
	$_von_monat = sprintf('%02d',$_von_monat);
	if(empty($bis)){
		$_bis = false;
	}
	else{
		list($_bis_monat,$_bis_jahr) = preg_split('~[^\d]+~',$bis,2);
		$_bis_monat = sprintf('%02d',$_bis_monat);
		if($_von_monat==$_bis_monat and $_von_jahr==$_bis_jahr){
			unset($bis,$_bis_monat,$_bis_jahr);
			$_bis = false;
		}
		else{
			$_bis = true;
		}
	}
	if($_bis and ($_von_jahr.$_von_monat > $_bis_jahr.$_bis_monat)){ # $bis groesser als $von
		return false;
	}


	$_w = $wochentag==7?0:$wochentag;
	# Monate suchen
	$daten = array();
	$daten[] = array('m'=>$_von_monat,'j'=>$_von_jahr);
	if($_bis){
		$i['m'] = $_von_monat;
		$i['j'] = $_von_jahr;
		while(true){
			$i['m']++;
			if($i['m']==13){
				$i['m'] = 1;
				$i['j']++;
			}
			$daten[] = array('m'=>sprintf('%02d',$i['m']),'j'=>$i['j']);
			if($i['m']==$_bis_monat and $i['j']==$_bis_jahr){
				break;
			}
		}
	}
	# Monate durchlaufen
	foreach($daten as $key => $monat){
		# ersten Tag ermitteln
		$tag = 1;
		$w = mktime(12,0,0,$monat['m'],$tag,$monat['j']);
		while(date('w',$w) != $_w){
			$tag++;
			$w = mktime(12,0,0,$monat['m'],$tag,$monat['j']);
		}
		$_erstertag = date('j',$w);

		# Trainingstage holen
		$maxtage = date('t',mktime(12,0,0,$monat['m'],$_erstertag,$monat['j']));
		$tag = $_erstertag;
		$ferientage = $this->holeFerientage($monat['m'],$monat['j']);
		$daten[$key]['t'] = array();
		while($tag <= $maxtage){
			if(!in_array($tag,$ferientage['ferientage'])){
				$daten[$key]['t'][] = $tag;
			}
			$tag += 7;
		}
	}
	return $daten;
}


function holeFerientage($monat='',$jahr=''){
	if(empty($monat)){
		$monat = $this->monat;
	}
	if(empty($jahr)){
		$jahr = $this->jahr;
	}
	$query = "SELECT CONCAT(art,'_',jahr,'_',nr) as id, DATE_FORMAT(von,'%e.%c.%Y') as von, DATE_FORMAT(bis,'%e.%c.%Y') as bis, bezeichnung
				FROM ".DB_PREFIX."ferien
				ORDER BY ".DB_PREFIX."ferien.von";
	$this->db->holeDaten($query);
	$anzahl_tage = date('t',mktime(3,0,0,$monat,1,$jahr));
	$ferien = array();
	$ferienids = array();
	for($i=1;$i<=$anzahl_tage;$i++){
		$tage_ferienid[$i] = '';
	}
	foreach($this->db->ergebnis['daten'] as $row){
		if(empty($row['bis'])){ # nur "von" beachten
			list($v_tag,$v_monat,$v_jahr) = explode('.',$row['von'],3);
			if($v_jahr != $jahr OR $v_monat != $monat){
				continue;
			}
			else{
				$ferien[] = $v_tag;
				$ferienids[] = $row['id'];
				$tage_ferienid[$v_tag] .= $row['id'].' ';
			}
		}
		else{ # auch "bis" beachten
			list($v_tag,$v_monat,$v_jahr) = explode('.',$row['von'],3);
			list($b_tag,$b_monat,$b_jahr) = explode('.',$row['bis'],3);
			if($v_jahr != $jahr AND $b_jahr != $jahr){
				# Ferien liegen nicht im gleichen Jahr (Ferien die über ein
				#   ganzes Jahr gehen, gibt es nicht)
				continue;
			}
			if($v_jahr < $jahr){
				# wenn das Anfangsjahr kleiner als das aktuelle ist, wird es auf
				#   das aktuelle gesetzt, sowie der Monat auf 1
				$v_jahr = $this->jahr;
				$v_monat = 1;
				$v_tag = 1;
			}
			if($b_jahr > $jahr){
				# wenn das Anfangsjahr größer als das aktuelle ist, wird es auf
				#   das aktuelle gesetzt, sowie der Monat auf 12
				$b_jahr = $this->jahr;
				$b_monat = 12;
				$b_tag = 31;
			}
			if($v_monat < $monat AND $b_monat < $monat){
				# Zeitraum liegt _vor_ dem gesuchten Monat
				continue;
			}
			if($v_monat > $monat AND $b_monat > $monat){
				# Zeitraum liegt _nach_ dem gesuchten Monat
				continue;
			}
			if($v_monat < $monat AND $b_monat > $monat){
				# im ganzen Monat sind Ferien
				$ferienids[] = $row['id'];
				for($i=1;$i<=$anzahl_tage;$i++){
					$ferien[] = $i;
					$tage_ferienid[$i] .= $row['id'].' ';
					continue;
				}
			}
			if($v_monat < $monat){
				# zu Beginn des Monats sind Ferien
				for($i=1;$i<=$b_tag;$i++){
					$ferien[] = $i;
					$tage_ferienid[$i] .= $row['id'].' ';
					continue;
				}
			}
			if($b_monat > $monat){
				# am Ende des Monats sind Ferien
				$ferienids[] = $row['id'];
				for($i=$v_tag;$i<=$anzahl_tage;$i++){
					$ferien[] = $i;
					$tage_ferienid[$i] .= $row['id'].' ';
					continue;
				}
			}
			if($b_monat == $monat and $v_monat == $monat){
				# die Ferien liegen komplett im Monat
				$ferienids[] = $row['id'];
				for($i=$v_tag;$i<=$b_tag;$i++){
					$ferien[] = $i;
					$tage_ferienid[$i] .= $row['id'].' ';
					continue;
				}
			}
		}
	}
	for($i=1;$i<=$anzahl_tage;$i++){
		if(empty($tage_ferienid[$i])){
			unset($tage_ferienid[$i]);
		}
		else{
			$tage_ferienid[$i] = trim($tage_ferienid[$i]);
		}
	}
	$rueckgabe['ferientage'] = array_unique($ferien);
	$rueckgabe['tage_ferienid'] = $tage_ferienid;
	return $rueckgabe;
}

function _berechneNaechstenMonat(){
	$jahr = ($this->monat == 12)?$this->jahr+1:$this->jahr;
	$monat = ($this->monat == 12)?1:$this->monat+1;
	$url = ROOT.'/sonstiges/kalender'.TKSWIM_DATEIENDUNG.'?monat='.$monat.'&amp;jahr='.$jahr;
	return array(
		'monat'=>$monat,
		'jahr'=>$jahr,
		'url'=> $url
	);
}

function _berechneVorherigenMonat(){
	$jahr = ($this->monat == 1)?$this->jahr-1:$this->jahr;
	$monat = ($this->monat == 1)?12:$this->monat-1;
	$url = ROOT.'/sonstiges/kalender'.TKSWIM_DATEIENDUNG.'?monat='.$monat.'&amp;jahr='.$jahr;
	return array(
		'monat'=>$monat,
		'jahr'=>$jahr,
		'url'=> $url
	);
}

function setzeMonat($monat){
	if(!empty($monat) AND $monat >= 1 AND $monat <= 12){
		$this->monat = $monat;
	}
	else{
		$this->monat = date('n');
	}
}

function setzeJahr($jahr){
	if(!empty($jahr) AND strlen($jahr) == 4 AND $jahr >= 1970 AND $jahr < 2038){
		$this->jahr = $jahr;
	}
	else{
		$this->jahr = date('Y');
	}
}

} # Ende der Klasse, EOF
