<?php

class lenex {

var $version = '3.0';

function __construct($version = NULL){
	if(!is_null($version)){
		$this->setzeVersion($version);
	}
	if(!defined('BR')){
		define('BR',PHP_EOL);
	}
}

function setzeVersion($version){
	if(strlen($version)==1){
		$version .= '.0';
	}
	$this->version = $version;
}

function _tf($wert, $art = 'xml'){
	if($art == 'date'){
		$art = 'dbdatum';
	}	
	if($art == 'st'){
		$art = 'schwimmzeit';
	}

	return text_format($wert, $art);
}


function erzeugeMeldedatei($daten, $wkdaten, $verein = false){
	$inhalt = '<?xml version="1.0" encoding="UTF-8"?>'.BR;
	$inhalt .= '<LENEX version="'.$this->version.'">'.BR;
	$inhalt .= '<CONSTRUCTOR name="tkswim" version="'.TKSWIM_VERSION.'">'.BR;
	$inhalt .= '	<CONTACT name="Tobias Kloth" country="GER" email="" internet="https://tkswim.de/" />'.BR;
	$inhalt .= '</CONSTRUCTOR>'.BR;
	$inhalt .= '<MEETS>'.BR;
  	$inhalt .= '	<MEET city="'.$this->_tf($wkdaten['ort']).'" name="'.$this->_tf($wkdaten['titel']).'" nation="GER">'.BR;
	
	$disziplinen = array(
		1 => 'FREE',
		2 => 'BREAST',
		3 => 'BACK',
		4 => 'FLY',
		5 => 'MEDLEY',
		6 => 'UNKNOWN'
	);
	
	$inhalt .= '		<SESSIONS>'.BR;
	# Wettkämpfe nach Abschnitten aufteilen
	$wks = array();
	foreach($daten['wettkaempfe'] as $wk){
		if(!isset($wks[$wk['nr']])){
			$wks[$wk['nr']] = array();
		}
		$tmp = '					<EVENT eventid="'.$wk['id'].'" gender="'.($wk['mw']=='W'?'F':$wk['mw']).'" number="'.$wk['wknr'].'">'.BR;
		if(strpos($wk['laenge'],'x') !== false){
			list($anz, $laenge) = explode('x', $wk['laenge']);
		}
		else{
			$anz = 1;
			$laenge = $wk['laenge'];
		}
		$tmp .= '						<SWIMSTYLE distance="'.$laenge.'" relaycount="'.$anz.'" stroke="'.$disziplinen[$wk['disziplin']].'" />'.BR;
		$tmp .= '					</EVENT>';
		$wks[$wk['nr']][] = $tmp;
	}
	
	foreach($daten['abschnitte'] as $abschn){
		$inhalt .= '			<SESSION date="'.$this->_tf($abschn['datum'], 'date').'" number="'.$this->_tf($abschn['nr']).'">'.BR;
		$inhalt .= '				<EVENTS>'.BR;
		if(isset($wks[$abschn['nr']])){
			foreach($wks[$abschn['nr']] as $wk){
				$inhalt .= $wk.BR;
			}
		}
		$inhalt .= '				</EVENTS>'.BR;
		$inhalt .= '			</SESSION>'.BR;
	}
	$inhalt .= '		</SESSIONS>'.BR;

	$inhalt .= '		<CLUBS>'.BR;
	$verein = $verein===false?TKSWIM_VEREIN:$verein;
	$inhalt .= '			<CLUB code="'.TKSWIM_VEREINSID.'" name="'.$this->_tf($verein).'" nation="GER" region="'.TKSWIM_LSVKENNZIFFER.'">'.BR;
	$a = &$daten['ansprechpartner'];
	$inhalt .= '				<CONTACT city="'.$this->_tf($a['ort']).'" country="GER" email="'.$this->_tf($a['email']).'" fax="'.$this->_tf($a['fax']).'" name="'.$this->_tf($a['name']).'" phone="'.$this->_tf($a['tel']).'" street="'.$this->_tf($a['strasse']).'" zip="'.$this->_tf($a['plz']).'" />'.BR;
	
	$inhalt .= '				<OFFICIALS>'.BR;
	global $_kampfrichtergruppen;
	foreach($daten['kampfrichter'] as $kari){
		list($nname, $vname) = explode(',', $kari['name']);
 		$inhalt .= '					<OFFICIAL firstname="'.$this->_tf(trim($vname)).'" lastname="'.$this->_tf($nname).'" gender="'.($kari['mw']=='w'?'F':'M').'" grade="'.$_kampfrichtergruppen[$kari['gruppe']].'" />'.BR;
	}
	$inhalt .= '				</OFFICIALS>'.BR;
		
	$inhalt .= '				<ATHLETES>'.BR;
	foreach($daten['einzelstarts'] as $id => $pers){
		list($nname, $vname) = explode(',', $pers['name']);
		$inhalt .= '					<ATHLETE firstname="'.$this->_tf(trim($vname)).'" lastname="'.$this->_tf($nname).'" gender="'.($pers['mw']=='w'?'F':'M').'" birthdate="'.$pers['jg'].'-01-01"'.(!empty($pers['dsvid'])?' license="'.$pers['dsvid'].'"':'').' athleteid="'.$id.'">'.BR;
		$inhalt .= '						<ENTRIES>'.BR;
		foreach($pers['_starts'] as $start){
			$zeit = is_null($start['zeit'])?'NT':'00:'.str_replace(',','.',$this->_tf($start['zeit'],'st'));
			$inhalt .= '							<ENTRY eventid="'.$start['wkid'].'" entrytime="'.$zeit.'" />'.BR;
		}
		$inhalt .= '						</ENTRIES>'.BR;
		$inhalt .= '					</ATHLETE>'.BR;
	}
	$inhalt .= '				</ATHLETES>'.BR;
	
	$inhalt .= '				<RELAYS>'.BR;
	$wkjahr = substr($wkdaten['datum'], -4);
	global $_altersklassen;
	foreach($daten['staffelstarts'] as $s){
		#$altermin
		
		$agemax = $agemin = $agetotalmax = $agetotalmin = "-1";
		if(!empty($s['klasse'])){
			if(substr($s['klasse'],0,2) == 'JG'){
				if(strlen($s['klasse']) == 7){ # nur ein Jahrgang
					$agemin = $agemax = $wkjahr-substr($s['klasse'],-4);
				}
				else{ # Jahrgang von-bis
					$agemin = $wkjahr-substr($s['klasse'],-9, -5);
					$agemax = $wkjahr-substr($s['klasse'],-4);
				}
			}
			else{
				if(strlen($s['klasse']) == 4){ # eine Jugendklasse
					$kl = strtolower(substr($s['klasse'],-1));
					$kl = $kl=='j'?'junioren':'j'.$kl;
					list($agemin, $agemax) = explode(',', $_altersklassen[$kl]);
				}
				else{ # eine Mastersklasse
					if(substr($s['klasse'],-1) == '+'){
						$agetotalmin = substr($s['klasse'],3,-1);
					}
					else{
						$agetotalmin = substr($s['klasse'],3);
						$agetotalmax = $agetotalmin+19;
					}
				}
			}
		}
		
		$inhalt .= '					<RELAY number="'.$s['nr'].'" agemin="'.$agemin.'" agemax="'.$agemax.'" agetotalmin="'.$agetotalmin.'" agetotalmax="'.$agetotalmax.'">'.BR;
		$inhalt .= '						<ENTRIES>'.BR;
		$zeit = '00:'.str_replace(',','.',$this->_tf($s['zeit'],'st'));
		$inhalt .= '							<ENTRY eventid="'.$daten['wettkaempfe'][$s['wknr']]['id'].'" entrytime="'.$zeit.'" />'.BR;
		$inhalt .= '						</ENTRIES>'.BR;
		$inhalt .= '					</RELAY>'.BR;
		
	}
	$inhalt .= '				</RELAYS>'.BR;
	$inhalt .= '			</CLUB>'.BR;
	$inhalt .= '		</CLUBS>'.BR;
	$inhalt .= '	</MEET>'.BR;
	$inhalt .= '</MEETS>'.BR;
	$inhalt .= '</LENEX>'.BR;
	
	return $inhalt;
	
}

} # Ende der Klasse, EOF
?>