<?php
require_once(PFAD_INCLUDE.'class/class.ezpdf.php');

class tkpdf extends Cezpdf {

var $tk_autor = '';
var $tk_titel = '';
var $tk_seitentitel = '';
var $tk_schriftgroesse = '';
var $tk_format = '';

function __construct($schriftgroesse = 10, $format = 'hoch'){

	if($_SERVER['REQUEST_METHOD'] == 'HEAD'){
		$this->tkstream('datei.pdf');
	}

	if(is_array($format)){
		parent::__construct($format[0],$format[1]);
	}
	else{
		if($format == 'quer'){
			parent::__construct('a4','landscape');
		}
		else{
			parent::__construct('a4','portrait');
		}
	}
	$this->tk_format = $format;
	$this->tk_schriftgroesse = $schriftgroesse;
	$this->selectFont(PFAD_INCLUDE.'export/pdf_fonts/Helvetica.afm');
	$tmp = array(
		'b'    => PFAD_INCLUDE.'export/pdf_fonts/Helvetica-Bold.afm',
		'i'    => PFAD_INCLUDE.'export/pdf_fonts/Helvetica-Oblique.afm',
		'bi'   => PFAD_INCLUDE.'export/pdf_fonts/Helvetica-BoldOblique.afm'
	);
	$this->setFontFamily(PFAD_INCLUDE.'export/pdf_fonts/Helvetica.afm',$tmp);
	$this->setLineStyle(1,'','','',0);
	$this->ezSetMargins(45,40,50,20);
}

function holeRandabstaende($art = 'pt', $querformat = false){
	global $_einst, $_gleinst;
	$abst = $_einst['globaleeinstellungen']['pdfdateiraender'];
	$abst = str_replace(' ','',$abst);
	$tmp = explode(',',$abst);

	switch($art){
	case 'pt':
		for($i=0;$i<4;$i++){
			$tmp[$i] /= 10;
			$tmp[$i] /= 2.54;
			$tmp[$i] *= 72;
		}
		break;
	default:
		break;
	}

	$abstaende = array(
		'oben'   => round($tmp[0],2),
		'rechts' => round($tmp[1],2),
		'unten'  => round($tmp[2],2),
		'links'  => round($tmp[3],2)
	);

	if($querformat){
		if($_einst['globaleeinstellungen']['pdfquerformatoben'] == 'rechts'){
			$tmp = array(
				'oben'   => $abstaende['rechts'],
				'rechts' => $abstaende['unten'],
				'unten'  => $abstaende['links'],
				'links'  => $abstaende['oben']
			);
		}
		else{
			$tmp = array(
				'oben'   => $abstaende['links'],
				'rechts' => $abstaende['oben'],
				'unten'  => $abstaende['rechts'],
				'links'  => $abstaende['unten']
			);
		}
		$abstaende = $tmp;
	}
	return $abstaende;
}


function tkgetTextWidth($schriftgroesse, $text){
	# problematische Zeichen im Text ersetzten
	$von  = array('ä','ö','ü','ß');
	$nach = array('a','o','u','s');
	$weg  = array('<b>','</b>','<i>','</i>');

	# Bei <b> und <i> den Text um ein 'm' pro 7 (bei fett) bzw. 12 (bei kursiv) Zeichen verlaengern
	if(strpos($text,'<b>')!==false and strpos($text,'</b>')!==false){
		preg_match_all('~<b>(.*?)</b>~',$text,$match);
		if(count($match[0])>0){
			foreach($match[1] as $fett){
				$anz = ceil(strlen($fett)/7);
				$text .= str_repeat('m',$anz);
			}
		}
	}
	if(strpos($text,'<i>')!==false and strpos($text,'</i>')!==false){
		preg_match_all('~<i>(.*?)</i>~',$text,$match);
		if(count($match[0])>0){
			foreach($match[1] as $fett){
				$anz = ceil(strlen($fett)/12);
				$text .= str_repeat('m',$anz);
			}
		}
	}
	$text = str_replace($von, $nach, $text);
	$text = str_replace($weg, '',    $text);
	# original getTextWidth() anwenden
	return $this->_original_getTextWidth($schriftgroesse,$text);
}


function _original_gettextwidth($size, $text){
# diese Funktion ist eine Kopie der Originalfunktion getTextWidth()
$store_currentTextState = $this->currentTextState;

if (!$this->numFonts){
	$this->selectFont('../pdf/fonts/Helvetica');
}

// converts a number or a float to a string so it can get the width
$text = "$text";

// hmm, this is where it all starts to get tricky - use the font information to
// calculate the width of each character, add them up and convert to user units
$w=0;
$len=strlen($text);
$cf = $this->currentFont;
for ($i=0;$i<$len;$i++){
	$f=1;
	$directive = $this->PRVTcheckTextDirective($text,$i,$f);
	if ($directive){
	if ($f){
		$this->setCurrentFont();
		$cf = $this->currentFont;
	}
	$i=$i+$directive-1;
	} else {
	$char=ord($text[$i]);
	if (isset($this->fonts[$cf]['differences'][$char])){
		// then this character is being replaced by another
		$name = $this->fonts[$cf]['differences'][$char];
		if (isset($this->fonts[$cf]['C'][$name]['WX'])){
		$w+=$this->fonts[$cf]['C'][$name]['WX'];
		}
	} else if (isset($this->fonts[$cf]['C'][$char]['WX'])){
		$w+=$this->fonts[$cf]['C'][$char]['WX'];
	}
	}
}
$this->currentTextState = $store_currentTextState;
$this->setCurrentFont();
return $w*$size/1000;
}



function tkaddText($x,$y,$schriftgroesse,$text,$winkel=0,$ausrichtung=0){
/* Die Methode entspricht der Funktion addText() der Originalklasse,
der Text wird lediglich durchgestrichen geschrieben; die Parameter
sind mit denen von addText() identisch.
*/
	if($winkel<0){
		$nachoben = true; # Schrift wird nach oben gedreht
	}
	else{
		$nachoben = false; # Schrift wird nach unten gedreht
	}
	while($winkel>360){ # Winkel groesser 360 um 360 verkleinern
		$winkel -= 360;
	}
	while($winkel<-360){ # Winkel kleiner 360 um 360 vergroessern
		$winkel += 360;
	}
	if($winkel<-180 and $winkel>=-360){ # Winkel auf den bereich -180<x<=180 bringen
		$winkel = 360+$winkel;
		$nachoben = !$nachoben;
	}
	if($winkel>180 and $winkel<=360){
		$winkel = 360-$winkel;
		$nachoben = !$nachoben;
	}
	$winkel = abs($winkel); # Absolutwert nehmen

	$schriftwinkel = $winkel;
	if($nachoben){
		$schriftwinkel = $winkel*-1;
	}
	# Text einfuegen
	$this->addText($x,$y,$schriftgroesse,$text,$schriftwinkel,$ausrichtung);
	# Umlaute machen Problem bei der Bestimmung der Schriftbreite -> ersetzten
	$breite = $this->tkgetTextWidth($schriftgroesse,$text);
	if($ausrichtung > 0){
		$breite += $ausrichtung*substr_count($text,' ');
	}
	# Linienbreite ist ein elftel der Schriftgroesse
	$this->setLineStyle($schriftgroesse/11);
	# die Linie zum Durchstreichen befindet sich in einem viertel der Schrifthoehe
	$r = $schriftgroesse/4;
	# x- und y- Positionen der Linie berechnen
	$bogenmasswinkel = deg2rad($winkel);
	# der Anfangspunkt der Linie beschreibt eine Kreisbahn, bei 0 Grad beginnend oben in der Mitte,
	#  wobei der Kreismittelpunkt der Drehpunkt der Schrift ist; $x_versch und $y_versch sind die
	#  Verschiebungen in x- bzw. y-Richtung vom Kreismittelpunkt aus gesehen.
	$x_versch = $r*sin($bogenmasswinkel);
	$y_versch = $r*cos($bogenmasswinkel);
	if($nachoben){
		$x_versch = $x_versch*-1;
	}
	$x_a = $x+$x_versch;
	$y_a = $y+$y_versch;
	$ankathete = $breite*cos($bogenmasswinkel);
	$gegenkathete = $breite*sin($bogenmasswinkel);
	$x_e = $x+$ankathete+$x_versch;
	if($nachoben){
		$y_e = $y+$gegenkathete+$y_versch;
	}
	else{
		$y_e = $y-$gegenkathete+$y_versch;
	}
	# Linie einfuegen
	$this->line($x_a,$y_a,$x_e,$y_e);
}


function tkform_tabelle($x, $y, $daten, $zeilenabstand, $schriftgroesse = 0){
/* Baut $daten als Tabelle in das Dokument ein
Parameter:
- $x: die x-Positionen der Spalten
- $y: die y-Position des oberen linken Kaestchens
- $daten: die einzufuegenden Daten
- $zeilenabstand: die Hoehe der Kaestchen
- $schriftgroesse: die Schriftgroesse des Textes
*/
	if($schriftgroesse > 0){
		$sg = $schriftgroesse;
	}
	else{
		$sg = empty($this->tk_schriftgroesse)?11:$this->tk_schriftgroesse;
	}
	$this->ezSetY($y);
	$einst = array(
		'xPos'         => $x[0],
		'xOrientation' => 'right',
		'fontSize'     => $schriftgroesse,
		'showLines'    => 0,
		'showHeadings' => 0,
		'shaded'       => 0,
		'rowGap'       => $zeilenabstand-$schriftgroesse,
		'cols'         => array(
			'nachname' => array(
				'width' => $x[1]-$x[0]
			),
			'vorname' => array(
				'width' => $x[2]-$x[1]
			),
			'jg' => array(
				'width' => $x[3]-$x[2]
			)
		)
	);
	$this->ezTable($daten,'','',$einst);
	$this->setStrokeColor(0,0,0);
}

function tkform_checkbox($groesse, $pos_x, $pos_y){
/* Macht ein Kreuz auf an die angegebene Position um Checkboxen auszufuellen
Parameter:
- $groesse: Seitenlaenge des Checkbox-Feldes (das Kreuz ist dann 2px kleiner)
- $pos_x:   x-Position des linken, unteren Eckes der Checkbox (von unten links)
- $pos_y:   y-Position
*/
	$verschiebung = 1;
	$liniendicke = round($groesse/10,1);
	$speicher = $this->currentLineStyle;
	$this->setLineStyle($liniendicke,'','',array(1,0));
	$l_x = $pos_x+$verschiebung;
	$r_x = $pos_x+$groesse-$verschiebung;
	$u_y = $pos_y+$verschiebung;
	$o_y = $pos_y+$groesse-$verschiebung;
	$this->line($l_x, $u_y, $r_x, $o_y);
	$this->line($r_x, $u_y, $l_x, $o_y);
	$this->currentLineStyle = $speicher;
}

function tkseitennummern($text = 'Seite {PAGENUM} von {TOTALPAGENUM}', $schriftgroesse = 0, $pos_x = 500, $pos_y = 20, $ausrichtung = 'right', $start = 1){
/*
Schreibt die Seitenzahl auf jede Seite
Parameter:
- $text: der zu schreibende Text (Standard: 'Seite x von y')
- $schriftgroesse: die gewuenschte Schriftgroesse (falls von $this->tk_schriftgroesse) abweichend
- $pos_x: die x-Position der Seitennummer (Standard: rechts unten)
- $pos_y: die y-Position der Seitennummer
- $ausrichtung: Ausrichtung des Textes
- $start: Bei dieser Zahl wird das Zaehlen angefangen
*/
	if(empty($text)){
		$text = 'Seite {PAGENUM} von {TOTALPAGENUM}';
	}
	if($schriftgroesse > 0){
		$sg = $schriftgroesse;
	}
	else{
		$sg = empty($this->tk_schriftgroesse)?11:$this->tk_schriftgroesse;
	}
	$all = $this->openObject();
	$this->saveState();
	if(!is_array($this->tk_format) and $this->tk_format == 'quer' and $pos_x == 500 and $pos_y == 20){
		$pos_x = 730;
	}
	$this->ezStartPageNumbers($pos_x, $pos_y, $sg, $ausrichtung, $text, $start);
	$this->restoreState();
	$this->closeObject();
	$this->addObject($all,'all');
	return true;
}

function tkseitentitel($text, $schriftgroesse = 0, $pos_x = 50, $pos_y = 810){
/*
Schreibt $text als Title auf jede Seite
Parameter:
- $text: der zu schreibende Text
- $schriftgroesse: die gewuenschte Schriftgroesse (falls von $this->tk_schriftgroesse) abweichend
- $pos_x: die x-Position des Titels
- $pos_y: die x-Position des Titels
*/
	if(empty($text)){
		return false;
	}
	if($schriftgroesse > 0){
		$sg = $schriftgroesse;
	}
	else{
		$sg = empty($this->tk_schriftgroesse)?12:$this->tk_schriftgroesse;
	}
	if(!is_array($this->tk_format) and $this->tk_format == 'quer' and $pos_y == 810){
		$pos_y = 555;
	}
	$all = $this->openObject();
	$this->saveState();
	$this->addText($pos_x, $pos_y, $sg, $text);
	$this->restoreState();
	$this->closeObject();
	$this->addObject($all,'all');
	return true;
}

function tkstream($dateiname='datei.pdf', $speicherart = false){
	$this->addInfo('Producer','PHP-Klasse mit PHP '.phpversion());
	$autor = !empty($this->tk_autor)?$this->tk_autor:'Tobias Kloth';
	$this->addInfo('Author',$autor);
	if(!empty($this->tk_titel)){
		$this->addInfo('Title',utf8_decode($this->tk_titel));
		$this->setPreferences('DisplayDocTitle','true');
	}

	$this->addInfo('Creator','tkswim '.TKSWIM_VERSION.' (->https://tkswim.de/)');
	$time = time();
	global $_monate;
	$this->addInfo('CreationDate',date('d. ',$time).$_monate[date('n',$time)].date(' Y - H:i',$time));

	if($speicherart=='rueckgabe'){
		return $this->ezoutput();
	}
	else{
		$this->ezStream(array('Content-Disposition'=>$dateiname));
	}
	global $_db;
	$_db->speichereGeaenderteTabellen();
	exit;
}

function tksquare($x,$y,$seitenlaenge,$strichsetzen = true){
/*
Zeichnet ein Quadrat mit der Seitenlaenge $seitenlaenge
$x und $y sind die Koordinaten des linken, unteren Eckes
*/
	if($strichsetzen){
		$speicher = $this->currentLineStyle;
		$this->setLineStyle(1,'','',array(1,0));
	}
	$this->line($x,$y,$x,$y+$seitenlaenge);
	$this->line($x,$y+$seitenlaenge,$x+$seitenlaenge,$y+$seitenlaenge);
	$this->line($x+$seitenlaenge,$y+$seitenlaenge,$x+$seitenlaenge,$y);
	$this->line($x+$seitenlaenge,$y,$x,$y);
	if($strichsetzen){
		$this->currentLineStyle = $speicher;
	}
}

} # Ende der Klasse, EOF
