<?php
if(!defined('PFAD_SMARTY')){
	trigger_error('[tkswim] [tktemplate] Smarty konnte nicht gefunden werden',E_USER_ERROR);
}

if(PFAD_SMARTY == ''){
	# Smarty suchen
	if(isset($_SESSION['_smarty'])){
		require_once($_SESSION['_smarty']);
	}
	else{
		if(file_exists(dirname(__FILE__).'/smarty/Smarty.class.php')){
			$_SESSION['_smarty'] = dirname(__FILE__).'/smarty/Smarty.class.php';
		}
		else{
			$open_basedir = ini_get('open_basedir');
			$document_root = $_SERVER['DOCUMENT_ROOT'];
			if(empty($open_basedir)){
				$anfang = '/';
			}
			else{
				$ob_teile = explode(PATH_SEPARATOR, $open_basedir);
				$anz = count($ob_teile);
				for($i=0;$i<$anz;$i++){
					if(substr($document_root, 0, strlen($ob_teile[$i])) == $ob_teile[$i]){
						$anfang = $ob_teile[$i];
						break;
					}
				}
			}
			if(substr($anfang,-1) != '/'){
				$anfang .= '/';
			}
			function sucheSmarty($anfang){
				$dh = opendir($anfang);
				if(!$dh){
					return false;
				}
				$datei = false;
				while (false !== ($file = readdir($dh))){
					if($file == '.' or $file == '..'){
						continue;
					}
					if(is_dir($anfang.$file)){
						$datei = sucheSmarty($anfang.$file.'/');
						if($datei !== false){
							break;
						}
					}
					if($file == 'Smarty.class.php'){
						$datei = $anfang.$file;
					}
				}
				closedir($dh);
				return $datei;
			}
			$_smarty = sucheSmarty($anfang);
			if($_smarty === false){
				die('Smarty wurde nicht gefunden, bitte erst in der config.inc.php Pfad zu Smarty angeben.');
			}
			$_SESSION['_smarty'] = $_smarty;
		}
		require_once($_SESSION['_smarty']);
	}
}
else{
	require_once(PFAD_SMARTY.'Smarty.class.php');
}

class tktemplate extends Smarty {

	function tktemplate(){
		if(defined('PFAD_TEMPLATES')){
			$this->template_dir = PFAD_TEMPLATES;
		}
		if(defined('PFAD_TEMPLATESC')){
			$this->compile_dir = PFAD_TEMPLATESC;
		}
		$this->plugins_dir = array();
		if(defined('PFAD_TMPLPLUGINS')){
			$this->plugins_dir[] = PFAD_TMPLPLUGINS;
		}
		$this->plugins_dir[] = 'plugins';
		$this->tk_js = array(
			'flags'   => array(
				'jsein'   => false,
				'sicherheitsabfrage' => false
			),
			'onready' => array(),
			'inline'  => '',
			'dateien' => array(),
			'ajaxdatei' => '/_ajax.php'
		);
	}

	function tk_javascriptzuweisen($art, $wert, $anfang=false){
		$this->tk_js['flags']['jsein'] = true;

		$codebloecke = array(



		);

		switch($art){
		case 'codeblock':
			if(isset($codebloecke[$wert])){
				$this->tk_js['inline'] .= $codebloecke[$wert]."\n";
			}
			break;

		case 'flag':
			if(strpos($wert, ':') !== false){
				$this->tk_js['flags'][substr($wert,-2)] = (substr($wert,-1)=='0'?false:true);
			}
			else{
				$this->tk_js['flags'][$wert] = true;
			}
			break;

		case 'ajaxdatei':
			$this->tk_js['ajaxdatei'] = $wert;
			break;

		case 'onready':
			if($anfang){
				array_unshift($this->tk_js['onready'], $wert);
			}
			else{
				$this->tk_js['onready'][] = $wert;
			}
			global $_einst;
			if($_einst['globaleeinstellungen']['sicherheitsabfragenabschalten'] and strpos($wert, 'tkswim_loeschfrage') !== false){
				$this->tk_js['flags']['sicherheitsabfrage'] = true;
			}
			break;

		case 'inline':
			$this->tk_js['inline'] = ($anfang?$wert.$this->tk_js['inline']:$this->tk_js['inline'].$wert)."\n\n";
			break;

		case 'dateien':
			if(!is_array($wert)){
				if(strpos($wert, ',') !== false){
					$wert = explode(',', $wert);
				}
				else{
					$wert = array($wert);
				}
			}
			foreach($wert as $datei){
				$this->tk_js['dateien'][] = $datei;
			}
			break;

		default:
			$this->trigger_error('$tpl_var ist ungültig.');
			break;
		}
		return;
	}

	function tk_javascriptvorbereiten(){
		$dateien = array(
			'jquery'                => 'jquery.1-5-2.js',
			'jquery.ui'             => 'jquery.ui.1-8-11.js',
			'jquery.message'        => 'jquery.message.1-0-0.js',
			'jquery.tablesorter'    => 'jquery.tablesorter.2-0-3.js',
			'jquery.tkswim'         => 'jquery.tkswim.0-1-6.js'
		);

		$js = array(
			'inline' => '',
			'dateien' => false
		);
		# Dateien
		foreach($dateien as $key => $datei){
			if(!in_array($key, $this->tk_js['dateien'])){
				continue;
			}
			if($js['dateien'] === false){
				$js['dateien'] = array();
			}
			$js['dateien'][] = ROOT.'/src/js/'.$dateien[$key];
		}

		# ajaxdatei
		$js['ajaxdatei'] = $this->tk_js['ajaxdatei'];

		# inline
		$js['inline'] = '';
		if($this->tk_js['flags']['jsein'] and ($js['dateien']!==false and in_array(ROOT.'/src/js/'.$dateien['jquery'], $js['dateien']))){
			$this->tk_javascriptzuweisen('onready', "\$('.js').show();", true);
			$js['inline'] .= "var ajaxdatei = '".ROOT.$js['ajaxdatei']."';\n";
		}
		if($this->tk_js['flags']['sicherheitsabfrage']){
			$js['inline'] .= "var keineloeschfrage = 1;\n";
		}
		if(!empty($this->tk_js['inline'])){
			$inline = $this->tk_js['inline'];
			$anz = preg_match('~[A-Z_]{2,}~', $inline, $match);
			if($anz > 0){
				foreach($match as $m){
					if(!defined($m)){
						continue;
					}
					$inline = str_replace($m, constant($m), $inline);
				}
			}
			$js['inline'] .= $inline;

		}
		$js['inline'] = trim($js['inline']);
		# onready
		if(count($this->tk_js['onready'])>0){
			$js['inline'] .= (!empty($js['inline'])?"\n\n":'')."\$(document).ready(function(){\n  ".implode("\n  ", $this->tk_js['onready'])."\n});";
		}
		$this->assign('js', $js);
	}

} # Ende der Klasse, EOF
