<?php

class zeitenexport {

var $jahr;
var $db;
var $datei;
var $einstellungen;
var $_einst;

function __construct($datei = '{default}', $jahr=''){
	if($datei == '{default}'){
		$datei = PFAD_INCLUDE.'ini_speicher/zeiten_export.ini';
	}
	if(file_exists($datei)){
		$this->datei = $datei;
	}
	else{
		trigger_error('[tkswim][class/zeitenexport/zeitenexport] Die Exportdatei existiert nicht.', E_USER_ERROR);
	}
	$this->jahr = empty($jahr)?date('Y'):$jahr;
	$this->einstellungen = array(
		'pflichtzeit'     => false,
		'toleranz'        => false,
		'nachweiszeitraum' => 6,
		'datum'           => '',
		'alter'           => false,
		'zeittyp'         => 'aktuelle',
		'maxalter'        => 15,
		'trainierende'    => 1,
		'auchnichtbestenlistenrelevante' => 0,
		'auchtrainingszeiten' => 1,
		'besteletzte'     => 'beste',
		'keinewettkampfteilnahme' => 1,
		'anzahlschwimmer' => 5,
		'keinelangsamenschwimmer' => false,
		'gruppierung'     => 'laengedisziplin',
		'sort1'           => 'jahrgak',
		'sort2'           => 'zeit',
		'sort3'           => '-',
		'sort4'           => '-',
		'sort5'           => '-',
		'sort6'           => '-',
		'sort7'           => '-',
		'nurdieseschwimmer'    => array(),
		'zufilterndeschwimmer' => array()
	);
}

function setzeJahr($jahr){
	if(strlen((int)$jahr) != 4){
		return false;
	}
	$this->jahr = $jahr;
	return true;
}

function legeDatensatzAn($titel=''){
	$titel = empty($titel)?'Zeitenexport '.date('Y-m-d H:i'):$titel;
	if(TKSWIM_SCHREIBSCHUTZ){ # temporären Datensatz anlegen
		return array(
			'id'    => false,
			'titel' => $titel.' (temporär)'
		);
	}
	else{ # normalen Datensatz anlegen
		$daten = parse_ini_file($this->datei, true);
		for($i=1;isset($daten[$i]);$i++);
		$daten[$i] = array();
		$daten[$i]['_daten'] = $_SESSION['user']['id'].';2;'.time().';'.$titel;
		require_once(PFAD_INCLUDE.'func/schreibe_ini_datei.inc.php');
		schreibe_ini_datei($this->datei, $daten, true);
		return array(
			'id'    => $i,
			'titel' => $titel
		);
	}
}

function holeDatensaetze(){
	$daten = parse_ini_file($this->datei, true);
	$datensaetze = array();
	$ids = array('mids'=>array(),'gruppen'=>array());
	# Datensaetze mit Zugriffsrechten suchen
	foreach($daten as $key => $datensatz){
		list($besitzer, $oeffentlich, $letzteaenderung, $name) = explode(';', $datensatz['_daten'], 4);
		$setzen = false;
		if($besitzer == $_SESSION['user']['id']){
			$setzen = true;
		}
		elseif($oeffentlich > 0 and in_array($oeffentlich, $_SESSION['user']['rechtegruppen'])){
			$setzen = true;
		}
		elseif(pruefeRechte('e_zeiten_alledatensaetze')){
			$setzen = true;
		}

		if($setzen){
			$ids['mids'][] = $besitzer;
			if($oeffentlich > 0){
				$ids['gruppen'][] = $oeffentlich;
			}
			$datensaetze[$key] = array(
				'id'              => $key,
				'besitzer'        => $besitzer,
				'besitzer_id'     => $besitzer,
				'oeffentlich'     => $oeffentlich,
				'oeffentlich_id'  => $oeffentlich,
				'letzteaenderung' => date('d.m.Y H:i',$letzteaenderung),
				'aenderungsort'   => $letzteaenderung,
				'name'            => $name,
				'zeilen'          => count($datensatz)-1
			);
		}
	}
	# Namen und Rechtegruppen lesbar machen
	if(count($ids['gruppen'])>0){
		$query = "SELECT id, bezeichnung FROM ".DB_PREFIX."rechtegruppen WHERE id IN (".implode(',',$ids['gruppen']).")";
		$this->db->holeDaten($query);
		$gruppen = $this->db->baueArray('bezeichnung', 'id');
	}
	if(count($ids['mids'])>0){
		$query = "SELECT id, CONCAT(nachname,', ',vorname) as name FROM ".DB_PREFIX."mitglieder WHERE id IN (".implode(',',$ids['mids']).")";
		$this->db->holeDaten($query);
		$mitglieder = $this->db->baueArray('name', 'id');
	}
	# sortieren
	if(!function_exists('sortfunktion')){
		function sortfunktion($a, $b){
			if($a['aenderungsort'] == $b['aenderungsort']){
				return 0;
			}
			return ($a['aenderungsort'] < $b['aenderungsort']) ? 1 : -1;
		}
	}
	usort($datensaetze, 'sortfunktion');

	$tmp = $datensaetze;
	$datensaetze = array();
	foreach($tmp as $row){
		$datensaetze[$row['id']] = $row;
		$datensaetze[$row['id']]['besitzer'] = $mitglieder[$row['besitzer']];
		if($row['oeffentlich'] > 0){
			$datensaetze[$row['id']]['oeffentlich'] = $gruppen[$row['oeffentlich']];
		}
		else{
			$datensaetze[$row['id']]['oeffentlich'] = '<em>keine</em>';
		}
	}
	# Daten zurückgeben
	return $datensaetze;
}

function setzeEinstellung($conf, $wert){
	if(!isset($this->einstellungen[$conf]) and $conf != 'altersklassen'){
		return false;
	}
	switch($conf){
	case 'pflichtzeit':
		if($wert === false){
			$this->einstellungen['pflichtzeit'] = false;
			break;
		}
		# Pflichtzeiten holen
		# Pflichtzeitdatensatz
		$query = "SELECT richtpflicht FROM ".DB_PREFIX."pflichtzeiten WHERE id = ".$wert;
		$this->db->holeDaten($query);
		$richtpflicht = $this->db->holeWert();
		# Jahrgänge
		$query = "SELECT id, jahrgang FROM ".DB_PREFIX."pflichtzeiten_jahrgaenge WHERE pflichtzeitenid = ".$wert;
		$this->db->holeDaten($query);
		$jahrgaenge = $_jahrgaenge = $this->db->baueArray('jahrgang', 'id');
		foreach($jahrgaenge as $id => $jg){
			$jahrgaenge[$id] = $this->_holeJahrgaenge($jg);
		}
		# Strecken
		$query = "SELECT id, disziplin, laenge, mw FROM ".DB_PREFIX."pflichtzeiten_strecken WHERE pflichtzeitenid = ".$wert;
		$this->db->holeDaten($query);
		$strecken = $this->db->baueArray('*', 'id');
		# die Pflichtzeiten selbst
		$query = "SELECT streckenid, jahrgangid, zeit FROM ".DB_PREFIX."pflichtzeiten_zeiten
					WHERE streckenid IN (".implode(',', array_keys($strecken)).") AND jahrgangid IN (".implode(',', array_keys($jahrgaenge)).")";
		$this->db->holeDaten($query);
		$daten = $this->db->baueArray('*', '#');
		$zeiten = array();
		foreach($daten as $row){
			if(!isset($zeiten[$row['jahrgangid']])){
				$zeiten[$row['jahrgangid']] = array();
			}
			if(!isset($zeiten[$row['jahrgangid']][$row['streckenid']])){
				$zeiten[$row['jahrgangid']][$row['streckenid']] = '';
			}
			$zeiten[$row['jahrgangid']][$row['streckenid']] = $row['zeit'];
		}
		$pflichtzeit = array(
			'id'           => $wert,
			'richtpflicht' => $richtpflicht,
			'strecken'     => $strecken,
			'jahrgaenge'   => $jahrgaenge, # Array mit den einzelnen Jahrgängen
			'_jahrgaenge'  => $_jahrgaenge, # Array mit den Jahrgangsdefinitionen aus den Pflichtzeiten
			'zeiten'       => $zeiten
		);
		# sonstige Einstellungen
		$this->einstellungen['pflichtzeit'] = $pflichtzeit;
		$this->einstellungen['alter'] = false;
		$this->einstellungen['besteletzte'] = 'beste';
		$this->einstellungen['gruppierung'] = '-';
		$this->einstellungen['sort1'] = 'name';
		$this->einstellungen['sort2'] = 'disziplin';
		$this->einstellungen['sort3'] = 'laenge';
		$this->einstellungen['anzahlschwimmer'] = false;
		break;

	case 'trainierende':
		$this->einstellungen[$conf] = $wert;
		if($wert == 1){
			$query = "SELECT DISTINCT mitgliedid 
						FROM ".DB_PREFIX."mitglieder_gruppen as g LEFT JOIN ".DB_PREFIX."trainingszeiten as z 
						  ON g.gruppenid=z.gruppenid
						WHERE z.von IS NOT NULL ORDER BY mitgliedid";
			$this->db->holeDaten($query);
			$this->einstellungen['nurdieseschwimmer'] = $this->db->baueArray('mitgliedid', '#');
		}
		break;

	case 'keinewettkampfteilnahme':
		$this->einstellungen[$conf] = $wert;
		if($wert == 1){
			$query = "SELECT artid FROM ".DB_PREFIX."eigenschaften WHERE art = 'm' AND eigenschaft = 'keinewettkampfteilnahme' ORDER BY artid";
			$this->db->holeDaten($query);
			$this->einstellungen['zufilterndeschwimmer'] = $this->db->baueArray('artid','#');
		}
		break;

	case 'alter':
		if($wert === false){
			$this->einstellungen[$conf] = false;
			break;
		}
		elseif($wert === ''){
			$this->einstellungen[$conf]['*'] = $this->_holeJahrgaenge('*');
			break;
		}
		$wert = str_replace(' ', '', $wert);
		if(strpos($wert, ',') !== false){
			$wert = explode(',', $wert);
		}
		else{
			$wert = array($wert);
		}
		$ausgang = array();
		foreach($wert as $w){
			$jg = $this->_holeJahrgaenge($w);
			if(count($jg)<1){
				return false;
			}
			$ausgang[$w] = $jg;
		}
		$this->einstellungen[$conf] = $ausgang;
		break;

	case 'altersklassen':
		$conf = 'alter';
		$aks = array();
		foreach($this->_einst['altersklassen'] as $ak => $alter){
			$akalter = explode(',', $this->_einst['altersklassen'][$ak]);
			if(in_array($ak, $wert)){
				$aks[$ak] = $this->_holeJahrgaenge($ak);
			}
		}
		$this->einstellungen[$conf] = $aks;
		break;

	default:
		$this->einstellungen[$conf] = $wert;
		break;
	}
	return true;
}


function _holeJahrgaenge($bereich){

	if(strpos($bereich,',') !== false){ # mehrere Werte mit Komma getrennt
		$bereiche = explode(',',$bereich);
		$ausgabe = array();
		foreach($bereiche as $b){
			$werte = $this->_holeJahrgaenge($b);
			foreach($werte as $w){
				$ausgabe[] = $w;
			}
		}
		$ausgabe = array_unique($ausgabe);
		sort($ausgabe);
		return $ausgabe;
	}
	
	if($bereich == '*'){
		return range($this->jahr-130, $this->jahr);
	}
	$undaelter = $undjuenger = false;
	$ausgang = array();
	$bereich = (string)$bereich;
	if(substr($bereich,-1) == '+'){
		$undaelter = true;
		$bereich = substr($bereich, 0, -1);
	}
	elseif(substr($bereich,-1) == '-'){
		$undjuenger = true;
		$bereich = substr($bereich, 0, -1);
	}

	if(ctype_digit($bereich) and strlen($bereich)==4){ # Jahrgangsangabe
		if($undaelter){
			$ausgang = range($this->jahr-130, $bereich);
		}
		elseif($undjuenger){
			$ausgang = range($bereich, $this->jahr);
		}
		else{
			$ausgang = array($bereich);
		}
	}
	elseif(strlen($bereich)==9 and substr($bereich,4,1) == '-'){ # JG bis JG
		list($v, $b) = explode('-', $bereich, 2);
		if($v > $b){
			$ausgang = range($b, $v);
		}
		else{
			$ausgang = range($v, $b);
		}
	}
	elseif(ctype_digit($bereich)){ # Altersangabe
		if($undaelter){
			$ausgang = range($this->jahr-130, $this->jahr-$bereich);
		}
		elseif($undjuenger){
			$ausgang = range($this->jahr-$bereich, $this->jahr);
		}
		else{
			$ausgang = array($this->jahr-$bereich);
		}
	}
	elseif(in_array($bereich, array_keys($this->_einst['altersklassen']))){ # Altersklasse
		if($bereich == 'ak95'){ # Sonderbehandlung für die AK95
			if($undjuenger){
				$ausgang = range($this->jahr-130, $this->jahr);
			}
			else{
				$ausgang = range($this->jahr-130, $this->jahr-95);
			}
			#continue;
		}
		# restliche Altersklassen
		$akalter = explode(',', $this->_einst['altersklassen'][$bereich]);
		if($undaelter){
			$ausgang = range($this->jahr-130, $this->jahr-min($akalter));
		}
		elseif($undjuenger){
			$ausgang = range($this->jahr-max($akalter), $this->jahr);
		}
		else{
			$ausgang = range($this->jahr-max($akalter), $this->jahr-min($akalter));
		}
	}
	else{
		# unbekannte Werte werden ignoriert
	}

	return $ausgang;
}


function holeZeiten($lagen, $strecken, $geschlecht){

	$rueckgabe = array();
	$kombinationen = array(
		1 => array(25,50,100,200,400,800,1500),
		2 => array(25,50,100,200),
		3 => array(25,50,100,200),
		4 => array(25,50,100,200),
		5 => array(100,200,400)
	);

	if($strecken === false){
		# wenn $strecken===false, stehen in $lagen die möglichen Kombinationen
		$kombinationen = $lagen;
		$lagen = array(1,2,3,4,5);
		$strecken = array(25,50,100,200,400,800,1500);
	}
	
	foreach($lagen as $lage){
		foreach($strecken as $strecke){
			if(!isset($kombinationen[$lage]) or !in_array($strecke, $kombinationen[$lage])){
				continue;
			}
			foreach($geschlecht as $mw){
				if($this->einstellungen['alter'] === false){
					$daten = $this->_holeZeiten($lage, $strecke, $mw, false);
					if(!is_array($daten)){
						continue;
					}
					foreach($daten as $dat){
						$dat['jgkey'] = '*';
						$rueckgabe[] = $dat;
					}
				}
				else{
					foreach($this->einstellungen['alter'] as $jgkey => $jahrgaenge){
						$daten = $this->_holeZeiten($lage, $strecke, $mw, $jahrgaenge);
						if(!is_array($daten)){
							continue;
						}
						foreach($daten as $dat){
							$dat['jgkey'] = $jgkey;
							$rueckgabe[] = $dat;
						}
						
					}
				}
			}
		}
	}
	$rueckgabe = $this->sortiereZeiten($rueckgabe);
	return $rueckgabe;
}

function _bauePflichtzeitenArray($daten, $zeiten, $art){
	# Arrays zum Mappen von Jahrgang/Strecke auf den jeweiligen Key der Pflichtzeiten
	if(!isset($this->einstellungen['pflichtzeit']['_jg2jgkey'])){
		$jg2jgkey = array();
		foreach($this->einstellungen['pflichtzeit']['jahrgaenge'] as $key => $jahrgaenge){
			foreach($jahrgaenge as $jg){
				$jg2jgkey[$jg] = $key;
			}
		}
		$this->einstellungen['pflichtzeit']['_jg2jgkey'] = $jg2jgkey;
		$strecke2streckenkey = array();
		foreach($this->einstellungen['pflichtzeit']['strecken'] as $key => $strecke){
			$strecke2streckenkey[$strecke['disziplin'].'_'.$strecke['laenge'].'_'.$strecke['mw']] = $key;
		}
		$this->einstellungen['pflichtzeit']['_strecke2streckenkey'] = $strecke2streckenkey;
	}
	else{
		$jg2jgkey = $this->einstellungen['pflichtzeit']['_jg2jgkey'];
		$strecke2streckenkey = $this->einstellungen['pflichtzeit']['_strecke2streckenkey'];
	}

	# Daten filtern
	$prozent = substr($this->einstellungen['toleranz'],-1)=='%';
	$toleranz = $prozent?(substr($this->einstellungen['toleranz'],0,-1)*0.01):($this->einstellungen['toleranz']*100);
	$istpflichtzeit = $this->einstellungen['pflichtzeit']['richtpflicht']=='p';
	foreach($daten as $key => $row){
		# Für die Jahrgänge gibt es keine Pflichtzeiten
		if(!array_key_exists($row['jg'], $jg2jgkey)){
			unset($daten[$key]);
			continue;
		}
		$strecke = $row['disziplin'].'_'.$row['laenge'].'_'.$row['mw'];		
		# Für den Jahrgang gibt es auf einer Strecke keine Pflichtzeiten
		if(!array_key_exists($strecke2streckenkey[$strecke], $this->einstellungen['pflichtzeit']['zeiten'][$jg2jgkey[$row['jg']]])){
			unset($daten[$key]);
			continue;
		}
		# auf Erfüllung der Pflichtzeit prüfen
		$pflichtzeit = $this->einstellungen['pflichtzeit']['zeiten'][$jg2jgkey[$row['jg']]][$strecke2streckenkey[$strecke]];
		if($prozent){
			$toleranz_absolut = $toleranz*$pflichtzeit;
		}
		else{
			$toleranz_absolut = $toleranz;
		}
		if($art=='nachweis'){ # Beim Pflichtzeitennachweis gibt es keine Toleranz, entweder die Pflichtzeit ist erfüllt oder nicht
			$pruefzeit = $pflichtzeit;
		}
		else{
			$pruefzeit = $istpflichtzeit?$pflichtzeit-$toleranz_absolut:$pflichtzeit+$toleranz_absolut;
		}
		# Ergebnis speichern
		$daten[$key]['pflichtzeit'] = $pflichtzeit;
		$daten[$key]['_bestanden'] = ($pruefzeit < $row['zeit'])?false:true;
		# Jahrgangsbereich speichern
		$daten[$key]['jgkey'] = $this->einstellungen['pflichtzeit']['_jahrgaenge'][$jg2jgkey[$row['jg']]];
	}

	# Daten im Ergebnisarray speichern
	foreach($daten as $row){
		$key = $row['mid'].'_'.$row['disziplin'].'_'.$row['laenge'];
		if($art == 'nachweis'){
			if(isset($zeiten[$key]) and $row['_bestanden']){
				$zeiten[$key]['_nachweis'] = $row['bahnlaenge'];
			}
			continue;
		}

		if(!isset($zeiten[$key])){
			$tmp = array(
				'mid'   => $row['mid'],
				'name'  => $row['name'],
				'mw'    => $row['mw'],
				'jg'    => $row['jg'],
				'jgkey' => $row['jgkey'],
				'disziplin'   => $row['disziplin'],
				'laenge'      => $row['laenge'],
				'pflichtzeit' => $row['pflichtzeit'],
				'bestanden'   => false,
				'_aktuelle' => false,
				'_letzte'   => false,
				'_beste'    => false,
				'_nachweis' => false
			);
		}
		else {
			$tmp = $zeiten[$key];
		}

		$tmp['_'.$art] = array(
			'zeit' => $row['zeit'],
			'id' => $row['zid'],
			'datum' => $row['datum'],
			'wettkampf' => $row['kurztitel'],
			'bahnlaenge' => $row['bahnlaenge'],
			'bestanden' => $row['_bestanden']
		);
		if($art == 'aktuelle'){
			$tmp['_'.$art]['interpoliert'] = $row['interpoliert'];
			$tmp['_'.$art]['vonlaenge'] = $row['vonlaenge'];
		}

		if($row['_bestanden']){
			$tmp['bestanden'] = true;
		}

		$zeiten[$key] = $tmp;
	}
	return $zeiten;
}


function holeZeitenFuerPflichtzeiten(){
	# Streckenkombinationen erzeugen
	$geschlecht = array();
	$kombinationen = array();
#$this->einstellungen['nurdieseschwimmer'] = array(1079);# __tk__
	foreach($this->einstellungen['pflichtzeit']['strecken'] as $row){
		$geschlecht[$row['mw']] = $row['mw'];
		if(!isset($kombinationen[$row['disziplin']])){
			$kombinationen[$row['disziplin']] = array();
		}
		if(in_array($row['laenge'], $kombinationen[$row['disziplin']])){
			continue;
		}
		$kombinationen[$row['disziplin']][] = $row['laenge'];
	}

	$this->setzeEinstellung('besteletzte', 'beste');
	$zeiten = array();
	# Zeiten aus aktuellen Zeiten holen
	$this->setzeEinstellung('zeittyp', 'aktuelle');
	$zeiten_aktuell = $this->holeZeiten($kombinationen, false, $geschlecht);
	$zeiten = $this->_bauePflichtzeitenArray($zeiten_aktuell, $zeiten, 'aktuelle');
	unset($zeiten_aktuell);

	# Zeiten aus echten Zeiten holen
	$this->setzeEinstellung('zeittyp', 'echte');
	$zeiten_echt = $this->holeZeiten($kombinationen, false, $geschlecht);
	$zeiten = $this->_bauePflichtzeitenArray($zeiten_echt, $zeiten, 'beste');
	unset($zeiten_echt);

	# letzte Zeiten holen
	$this->setzeEinstellung('besteletzte', 'letzte');
	$zeiten_letzte = $this->holeZeiten($kombinationen, false, $geschlecht);
	$zeiten = $this->_bauePflichtzeitenArray($zeiten_letzte, $zeiten, 'letzte');
	unset($zeiten_letzte);

	# Mitglieder/Strecken ohne erfüllte Pflichtzeit rauswerfen
	foreach($zeiten as $key => $row){
		if($row['bestanden']===false){
			unset($zeiten[$key]);
		}
	}

	# Zeiten für den Pflichtzeitennachweis holen
	if($this->einstellungen['pflichtzeit']['richtpflicht']=='p'){ # Bei Richtzeiten brauchen wir keinen Pflichtzeitennachweis
		$this->setzeEinstellung('besteletzte', 'beste');
		$this->setzeEinstellung('maxalter', $this->einstellungen['nachweiszeitraum']);
		$zeiten_nachweis = $this->holeZeiten($kombinationen, false, $geschlecht);
		$zeiten = $this->_bauePflichtzeitenArray($zeiten_nachweis, $zeiten, 'nachweis');
		unset($zeiten_nachweis);
	}

	# Zeiten nach Mitgliedern gruppieren
	$ausgang = array();
	$mids = array();
	foreach($zeiten as $row){
		#printr($zeiten);exit; #__tk__
	#if($row['mid']!='1079')continue;	
		
		if(!isset($ausgang[$row['mid']])){
			$ausgang[$row['mid']] = array(
				'mid' => $row['mid'],
				'name' => $row['name'],
				'mw' => $row['mw'],
				'jg' => $row['jg'],
				'jgkey' => $row['jgkey'],
				'registriert' => 0,
				'lizenziert' => 0,
				'_strecken' => array()
			);
			$mids[] = $row['mid'];
		}
		$ausgang[$row['mid']]['_strecken'][$row['disziplin'].'_'.$row['laenge']] = array(
			'disziplin'   => $row['disziplin'],
			'laenge'      => $row['laenge'],
			'pflichtzeit' => $row['pflichtzeit'],
			'_aktuelle'   => $row['_aktuelle'],
			'_letzte'     => $row['_letzte'],
			'_beste'      => $row['_beste'],
			'_nachweis'   => $row['_nachweis']
		);
	}
	unset($zeiten);
	
	# Lizenzinformationen zum Mitglied speichern
	if(count($mids)>0){
		$query = "SELECT m.id as mid, IF(m.dsvid IS NULL, 0,1) as registriert, IF(l.jahr IS NULL, 0,1) as lizenziert 
					FROM ".DB_PREFIX."mitglieder as m LEFT JOIN ".DB_PREFIX."lizenzierungen as l 
					  ON m.id=l.mitgliedid AND l.jahr = ".substr($this->einstellungen['datum'],-4)."
					WHERE m.id IN (".implode(',',$mids).")";
		$this->db->holeDaten($query);
		$daten = $this->db->baueArray('*','mid');
		foreach($daten as $row){
			$ausgang[$row['mid']]['registriert'] = $row['registriert'];
			$ausgang[$row['mid']]['lizenziert'] = $row['lizenziert'];
		}
	}
	
	# fertig
	return $ausgang;
}

function formatiereAltersklasse($wert){
	if($wert == '*'){
		return 'offen';
	}
	$ausgabe = $wert;
	# + und - aus $wert entfernen und zwischenspeichern
	$undaelter = $undjuenger = false;
	if(substr($wert,-1) == '+'){
		$undaelter = true;
		$wert = substr($wert, 0, -1);
	}
	elseif(substr($wert,-1) == '-'){
		$undjuenger = true;
		$wert = substr($wert, 0, -1);
	}
	else{
		$wert = substr($wert, 0); # ohne die Zeile werden Altersangaben nicht erkannt
	}

	# Jahrgänge, Alter und Altersklassen formatieren
	if(ctype_digit($wert) and strlen($wert)==4){ # Jahrgangsangabe
		$ausgabe = 'Jahrgang '.$wert;
	}
	elseif(ctype_digit($wert)){ # Altersangabe
		$ausgabe = $wert.' Jahre';

	}
	elseif(in_array($wert, array_keys($this->_einst['altersklassen']))){ # Altersklasse
		if(substr($wert,0,2) == 'ak'){
			$ausgabe = strtoupper($wert);
		}
		elseif($wert == 'junioren'){
			$ausgabe = 'Junioren';
		}
		elseif($wert[0]=='j'){
			$ausgabe = 'Jugend '.strtoupper($wert[1]);
		}
	}

	# ggf. und älter/und jünger wieder anhängen
	if($undaelter){
		$ausgabe .= ' und älter';
	}
	elseif($undjuenger){
		$ausgabe .= ' und jünger';
	}
	return $ausgabe;
}


function _holeZeiten($lage, $strecke, $mw, $jahrgaenge){
	# Queryteile zusammenbauen
	$_jahrgaenge = '';
	if($jahrgaenge !== false){
		$_jahrgaenge = 'AND YEAR(gebdatum) '.(count($jahrgaenge)==1?'= '.$jahrgaenge[0]:"IN (".implode(',', $jahrgaenge).")");
	}
	$_zufilterndeschwimmer = '';
	if(count($this->einstellungen['zufilterndeschwimmer'])>0){
		$_zufilterndeschwimmer = "AND m.id NOT IN (".implode(',', $this->einstellungen['zufilterndeschwimmer']).")";
	}
	$_nurdieseschwimmer = ' AND m.ausgetreten IS NULL';
	if(count($this->einstellungen['nurdieseschwimmer'])>0){
		$_nurdieseschwimmer = "AND m.id IN (".implode(',', $this->einstellungen['nurdieseschwimmer']).")";
	}
	$_pflichtzeiten = $this->einstellungen['pflichtzeit']!==false;
	$_zusatzspalten = $_pflichtzeiten?", w.bahnlaenge, YEAR(gebdatum) as jg, z.id  as zid, z.streckenlaenge as vonlaenge":'';
	$_vergleichsdatum = !empty($this->einstellungen['datum'])?"'".text_format($this->einstellungen['datum'],'dbdatum')."'":'NOW()';
	$_limit = $this->einstellungen['anzahlschwimmer']===false?'':' LIMIT '.$this->einstellungen['anzahlschwimmer'];

	if($this->einstellungen['zeittyp'] == 'echte'){
		# IDs der letzten bzw. besten Zeit holen
		$query = "SELECT id, mitgliedid
					FROM ".DB_PREFIX."zeiten as z
					WHERE
					  zeit IS NOT NULL AND
					  streckenlaenge = ".$strecke." AND
					  disziplin = ".$lage." AND
					  ".($this->einstellungen['auchtrainingszeiten']!=1?'wettkampfid > 5 AND':'')."
					  ".($this->einstellungen['auchnichtbestenlistenrelevante']!=1?'bestenliste = 1 AND':'')."
					  DATE_ADD(datum, INTERVAL ".$this->einstellungen['maxalter']." MONTH) >= ".$_vergleichsdatum."
					ORDER BY mitgliedid, ".($this->einstellungen['besteletzte']=='beste'?'zeit ASC':'z.datum DESC')."";
		$this->db->holeDaten($query);
		$tmp = $this->db->baueArray('mitgliedid', 'id');
		$zeitids = array();
		# zu jedem Mitglied eine ID rausfiltern
		foreach($tmp as $zid => $mid){
			if(isset($zeitids[$mid])){
				continue;
			}
			$zeitids[$mid] = $zid;
		}

		if(count($zeitids)<1){
			return false;
		}
		# gesuchte Daten holen
		$query = "SELECT CONCAT(nachname, ', ',vorname, ' (',mw,', ',YEAR(gebdatum),')') as name, m.id as mid, m.mw as mw,
					  z.streckenlaenge as laenge, z.disziplin, z.zeit, 0 as interpoliert, w.kurztitel,
					  DATE_FORMAT(z.datum, '%d.%m.%Y') as datum".$_zusatzspalten."
					FROM (".DB_PREFIX."mitglieder as m LEFT JOIN ".DB_PREFIX."zeiten as z ON m.id=z.mitgliedid)
					LEFT JOIN ".DB_PREFIX."wettkaempfe as w ON z.wettkampfid = w.id
					WHERE
					  m.mw = '".$mw."'
					  ".$_jahrgaenge."
					  ".$_zufilterndeschwimmer."
					  ".$_nurdieseschwimmer."
					AND z.id IN (".implode(',',$zeitids).")
					ORDER BY zeit ASC".$_limit;
		$this->db->holeDaten($query);
		if($this->db->holeAnzahl() < 1){
			return false;
		}
	}
	else{ # aktuelle Zeiten
		$query = "SELECT CONCAT(nachname, ', ',vorname, ' (',mw,', ',YEAR(gebdatum),')') as name, m.id as mid, m.mw as mw, a.laenge, a.disziplin,
					  a.zeit, IF(a.laenge=z.streckenlaenge,0,1) as interpoliert, w.kurztitel,
					  DATE_FORMAT(z.datum, '%d.%m.%Y') as datum".$_zusatzspalten."
					FROM ((".DB_PREFIX."aktuellezeiten as a LEFT JOIN ".DB_PREFIX."mitglieder as m ON m.id=a.mid)
					  LEFT JOIN ".DB_PREFIX."zeiten as z ON a.zeitid=z.id) LEFT JOIN ".DB_PREFIX."wettkaempfe as w ON z.wettkampfid = w.id
					WHERE
					  a.laenge = ".$strecke." AND
					  a.disziplin = ".$lage." AND
					  m.mw = '".$mw."'
					   ".$_jahrgaenge."
					  ".$_zufilterndeschwimmer."
					  ".$_nurdieseschwimmer."
					ORDER BY zeit ASC".$_limit;
		$this->db->holeDaten($query);
		if($this->db->holeAnzahl() < 1){
			return false;
		}
	}
	$daten = $this->db->baueArray('*','#');
	# ggf. langsame Schwimmer aussortieren
	if($this->einstellungen['keinelangsamenschwimmer'] !== false){
		$schnellstezeit = $daten[0]['zeit'];
		$grenze = ($schnellstezeit*($this->einstellungen['keinelangsamenschwimmer']/100))+$schnellstezeit;
		foreach($daten as $key => $row){
			if($row['zeit'] <= $grenze){
				continue;
			}
			unset($daten[$key]);
		}
	}
	# Daten zurückgeben
	return $daten;
}


function schreibeZeitenInExportDatei($daten, $datensatzid, $ersetzen = false){
	if(TKSWIM_SCHREIBSCHUTZ){
		return false;
	}
	if(count($daten) < 1 and $ersetzen === false){
		return false;
	}
	# Datei einlesen
	$vorhandene = parse_ini_file(PFAD_INIDATEIEN.'zeiten_export.ini', true);
	if(!isset($vorhandene[$datensatzid])){
		return false;
	}
	if($ersetzen){
		$dat = $vorhandene[$datensatzid]['_daten'];
		$vorhandene[$datensatzid] = array();
		$vorhandene[$datensatzid]['_daten'] = $dat;
	}
	# Daten zusammenfügen
	foreach($daten as $row){
		$name = str_replace(';', ',', $row['name']);
		$wettkampf = str_replace(';', ',', $row['kurztitel']);
		$zeile = $row['mid'].';'.$name.';'.$row['mw'].';'.$row['zeit'].';'.$row['interpoliert'].';'.$row['laenge'].';'.$row['disziplin'].';';
		$zeile .= $row['datum'].';'.$wettkampf.';'.$row['jgkey'];
		$vorhandene[$datensatzid][] = $zeile;
	}
	# Änderungsdatum aktualisieren
	$dat = explode(';', $vorhandene[$datensatzid]['_daten'], 4);
	$dat[2] = time();
	$vorhandene[$datensatzid]['_daten'] = implode(';', $dat);
	# Daten schreiben
	require_once(PFAD_INCLUDE.'func/schreibe_ini_datei.inc.php');
	schreibe_ini_datei(PFAD_INIDATEIEN.'zeiten_export.ini', $vorhandene, true);
	# Anzahl der geschriebenen Datensätze zurückgeben
	return count($daten);
}


/*
function datenAlsDateiExportieren($art,$daten){
	$erlaubt = array('pdf','csv','ods');
	if(!in_array($art,$erlaubt)){
		return false;
	}

	# Einelne Exportarten
	if($art == 'pdf'){
		require_once(PFAD_INCLUDE.'class/pdf.inc.php');
		if($_SERVER['REQUEST_METHOD'] == 'HEAD'){
			$pdf = new tkpdf();
			$pdf->tkstream('zeitenexport_foobar_'.date('Y-m-d_H-i').'.pdf');
		}

		$pdf = new tkpdf;
		# Einstellungen
		$titel = 'Zeitenexport, '.date('d.m.Y H:i');
		$optionen = array(
			'fontSize' => $pdf->tk_schriftgroesse,
			'titelFontSize' => $pdf->tk_schriftgroesse,
			'xPos' => 50,
			'xOrientation' => 'right',
			'shaded' => 0,
			'showLines' => 2,
			'colGap' => 6,
			'rowGap' => 1,
			'innerLineThickness' => 0.5,
			'outerLineThickness' => 1.0
		);

		# Export
		$pdf->tkseitennummern();
		$pdf->tk_titel = $titel;
		$pdf->tkseitentitel($titel);
		$pdf->tk_autor = $_SESSION['user']['realname'];
		$pdfdaten = $this->macheDatenLesbar($_POST['optionen']['m_gruppierung'],$daten);
		if($_POST['optionen']['m_gruppierung'] ==  '-'){
			$spalten = array('name'=>'Name','lage_k'=>'Lage','zeit'=>'Zeit','datum'=>'Datum','wk'=>'Wettkampf','jg'=>'Jahrgang');
			$y = $pdf->ezTable($pdfdaten,$spalten,'',$optionen);
		}
		else{
			$y = 0;
			if($_POST['optionen']['m_gruppierung'] == 'laengedisziplin'){
				$spalten = array('name'=>'Name','zeit'=>'Zeit','datum'=>'Datum','wk'=>'Wettkampf','jg'=>'Jahrgang');
			}
			if($_POST['optionen']['m_gruppierung'] == 'name'){
				$spalten = array('lage_l'=>'Disziplin','zeit'=>'Zeit','datum'=>'Datum','wk'=>'Wettkampf');
			}
			if($_POST['optionen']['m_gruppierung'] == 'jahrgak'){
				$spalten = array('name'=>'Name','lage_l'=>'Disziplin','zeit'=>'Zeit','datum'=>'Datum','wk'=>'Wettkampf');
			}
			$anz = count($pdfdaten);
			for($i=0;$i<$anz;$i++){
				$y = $pdf->ezText('<b>'.$pdfdaten[$i]['titel'].'</b>', $pdf->tk_schriftgroesse+1);
				$pdf->ezSetDy(-6);
				$y = $pdf->ezTable($pdfdaten[$i]['daten'],$spalten, '', $optionen);
				if($y < 100 and isset($pdfdaten[$i+1])){
					$pdf->eznewPage();
				}
				$pdf->ezSetDy(-12);
			}
		}
		$pdf->tkstream('zeitenexport_'.date('Y-m-d_H-i').'.pdf',false);
	}
	elseif($art == 'csv'){
		global $_einst;
		$tr = $_einst['dateisystem']['csvdateitrenner']=='tab'?"\t": $_einst['dateisystem']['csvdateitrenner'];
		$br = PHP_EOL;
		$ausg = 'Nachname'.$tr.'Vorname'.$tr.'mw'.$tr.'JG'.$tr.'Lage'.$tr.'Zeit'.$tr.'Datum'.$tr.'Wettkampf'.$tr.'Jahrgang'.$br;
		$csvdaten = $this->macheDatenLesbar('-',$daten);
		foreach($csvdaten as $row){
			preg_match('~^([^,]+), ([^ ]+) \((m|w), (\d{4})\)$~',$row['name'],$match);
			list(,$nachname,$vorname,$mw,$jg) = $match;
			$ausg .= '"'.$nachname.'"'.$tr.'"'.$vorname.'"'.$tr.'"'.$mw.'"'.$tr.'"'.$jg.'"'.$tr;
			$ausg .= '"'.$row['lage_l'].'"'.$tr.'"'.$row['zeit'].'"'.$tr.'"'.$row['datum'].'"'.$tr.'"'.$row['wk'].'"'.$tr.'"'.$row['jg'].'"'.$br;

		}
		$dateiname = 'zeitenexport_'.date('Y-m-d_H-i').'.csv';
		header('Content-Type: text/comma-separated-values');
		header('Content-Length: '.strlen($ausg));
		header('Content-Disposition: attachment; filename="'.$dateiname.'"');
		echo $ausg;
		exit;
	}
	return true;
}
*/


function sortiereZeiten($daten){

	# "zuständige" Felder
	$this->sortieren['zustaendigesfeld'] = array(
		'name'      => 'name',
		'mw'        => 'mw',
		'laengedisziplin' => '_streckelage',
		'jahrgak'   => '_jgkey',
		'jahrgang'  => '_jg',
		'disziplin' => 'disziplin',
		'laenge'    => 'laenge',
		'zeit'      => 'zeit'
	);

	# Sortierkriterien einsammeln
	$sortkriterien = array();
	if($this->einstellungen['gruppierung'] != '-'){
		$sortkriterien[] = $this->einstellungen['gruppierung'];
	}
	$i = 1;
		
	while(isset($this->einstellungen['sort'.$i])){
		if($this->einstellungen['sort'.$i] == '-'){
			$i++;
			continue;
		}
		$sortkriterien[] = $this->einstellungen['sort'.$i];
		$i++;
	}

	# Jahrgangssort setzen (sofern noetig)
	if(in_array('jahrgak', $sortkriterien)){
		$this->jahrgangsaksort = array();
		$tmp = array();
		foreach($daten as $row){
			if(isset($tmp[$row['jgkey']])){
				continue;
			}
			$jgs = $this->_holeJahrgaenge($row['jgkey']);
			if(count($jgs) == 1){
				$tmp[$row['jgkey']] = $jgs[0];
			}
			elseif(substr($row['jgkey'],-1) == '+'){
				$tmp[$row['jgkey']] = max($jgs);
			}
			else{
				$tmp[$row['jgkey']] = min($jgs);
			}
		}
		asort($tmp);
		$i = 1;
		foreach($tmp as $key => $jg){
			$this->jahrgangsaksort[$key] = $i;
			$i++;
		}
		unset($tmp);
	}

	# Spezialfelder zum Sortieren erzeugen (bei der Sortierung nach »laengedisziplin«, »jahrgak« und »jahrgang«)
	$spezialfelder = array('laengedisziplin', 'jahrgak', 'jahrgang');
	foreach($sortkriterien as $key => $sortwert){
		if(!in_array($sortwert, $spezialfelder)){
			continue;
		}
		switch($sortwert){
		case 'laengedisziplin':
			foreach($daten as $dkey => $row){
				$daten[$dkey]['_streckelage'] = $row['disziplin'].str_pad($row['laenge'], 4, '0', STR_PAD_LEFT);
			}
			break;
		case 'jahrgak':
			foreach($daten as $dkey => $row){
				$daten[$dkey]['_jgkey'] = $this->jahrgangsaksort[$row['jgkey']];
			}
			break;
		case 'jahrgang':
			foreach($daten as $dkey => $row){
				$daten[$dkey]['_jg'] = substr($row['name'], -5, -1);
			}
		}
	}
	# Kriterien entfernen nach denen nicht sortiert werden kann (da alle Datensätze den gleichen Wert enthalten)
	foreach($sortkriterien as $key => $sortwert){
		$werte = array();
		foreach($daten as $row){
			$werte[] = $row[$this->sortieren['zustaendigesfeld'][$sortwert]];
		}
		$werte = array_unique($werte);
		if(count($werte) == 1){
			unset($sortkriterien[$key]);
		}
	}
	# sortkriterien-Klassenweit bekanntmachen
	$this->sortieren['sortkriterien'] = array();
	foreach($sortkriterien as $t){
		$this->sortieren['sortkriterien'][] = $t;
	}
	$daten = $this->_sortiereZeiten($daten, 0);
	# aufräumen
	if(isset($this->jahrgangsaksort)){
		unset($this->jahrgangsaksort);
	}
	unset($this->sortieren);

	return $daten;
}


function _sortiereZeiten($daten, $keynr){
	
	if($keynr == 0){
		$this->sortieren['ergebnis'] = array();
	}

	if(count($this->sortieren['sortkriterien']) < 1){
		return $daten;
	}
	$sortwert = $this->sortieren['sortkriterien'][$keynr];

	# Sortieren
	$sort = array();
	foreach($daten as $key => $row){
		$sort[$key] = $row[$this->sortieren['zustaendigesfeld'][$sortwert]];
	}
	asort($sort);
	$rueckgabe = array();
	foreach($sort as $key => $row){
		$rueckgabe[] = $daten[$key];
	}
	$daten = $rueckgabe;

	# es gibt keine weiteren Kriterien -> Daten in das Ausgabearray schreiben
	if(!isset($this->sortieren['sortkriterien'][$keynr+1])){
		foreach($daten as $row){
			 $this->sortieren['ergebnis'][] = $row;
		}
		if($keynr == 0){
			return $this->sortieren['ergebnis'];
		}
		else{
			return true;
		}
	}

	# auftrennen
	$teile = array();
	$aktuellerwert = '';
	$i = 0;
	foreach($daten as $row){
		if($row[$this->sortieren['zustaendigesfeld'][$sortwert]] != $aktuellerwert){
			$i++;
			$aktuellerwert = $row[$this->sortieren['zustaendigesfeld'][$sortwert]];
		}
		$teile[$i][] = $row;
	}
	# einzelne Teile nach dem nächsten Kriterium sortieren
	foreach($teile as $teil){
		$this->_sortiereZeiten($teil, $keynr+1);
	}

	# am Ende fertige Daten zurückgeben
	if($keynr == 0){
		return $this->sortieren['ergebnis'];
	}
}

} # Ende der Klasse, EOF
