<?php

class zipfile {

var $ctrl_dir     = '';
var $eof_ctrl_dir = "\x50\x4b\x05\x06\x00\x00\x00\x00";
var $old_offset   = 0;
var $tk_dateien   = 0;
var $tk_laengedaten = 0;
var $tk_metadaten = '';
var $tk_tmpdatei  = '';
var $tk_fhtmpdat  = NULL;

function __construct(){
	$this->tk_tmpdatei = PFAD_TMP.'zip_'.md5(uniqid(rand()).rand());
	$this->tk_fhtmpdat = fopen($this->tk_tmpdatei, 'w');
}

function speichereDatei($pfad){
	$this->_stelleDateiFertig();
	if(!is_writable(dirname($pfad))){
		return false;
	}
	rename($this->tk_tmpdatei, $pfad);
	return true;
}

function gebeDateiAus($dateiname = 'datei.zip', $contenttype = 'application/zip'){
	$this->_stelleDateiFertig();
	header('Content-Type: '.$contenttype);
	header('Content-Length: '.filesize($this->tk_tmpdatei));
	header('Content-Disposition: attachment; filename="'.$dateiname.'"');
	readfile($this->tk_tmpdatei);
	unlink($this->tk_tmpdatei);
	exit;
}

function verwerfeDatei(){
	fclose($this->tk_fhtmpdat);
	unlink($this->tk_tmpdatei);
	return true;
}

function _stelleDateiFertig(){
	$schreiben = $this->tk_metadaten;
	$schreiben .= $this->eof_ctrl_dir;
	$schreiben .= pack('v', $this->tk_dateien); // total # of entries "on this disk"
	$schreiben .= pack('v', $this->tk_dateien); // total # of entries overall
	$schreiben .= pack('V', strlen($this->tk_metadaten)); // size of central dir
	$schreiben .= pack('V', $this->tk_laengedaten); // offset to start of central dir
	$schreiben .= "\x00\x00"; // .zip file comment length
	fwrite($this->tk_fhtmpdat, $schreiben, strlen($schreiben));
	fclose($this->tk_fhtmpdat);
	return true;
}

function addFile_pfad($pfad, $name, $zeit = 0){
	if(!file_exists($pfad)){
		return false;
	}
	$daten = file_get_contents($pfad);
	return $this->addFile_daten($daten, $name, $zeit);
}

function addFile_daten($daten, $name, $zeit = 0){
	$name     = str_replace('\\', '/', $name);
	$dtime    = dechex($this->unix2DosTime($zeit));
	$hexdtime = '\x' . $dtime[6] . $dtime[7]
			. '\x' . $dtime[4] . $dtime[5]
			. '\x' . $dtime[2] . $dtime[3]
			. '\x' . $dtime[0] . $dtime[1];
	eval('$hexdtime = "' . $hexdtime . '";');
	$fr  = "\x50\x4b\x03\x04";
	$fr .= "\x14\x00";            // ver needed to extract
	$fr .= "\x00\x00";            // gen purpose bit flag
	$fr .= "\x08\x00";            // compression method
	$fr .= $hexdtime;             // last mod time and date
	// "local file header" segment
	$unc_len = strlen($daten);
	$crc     = crc32($daten);
	$zdata   = gzcompress($daten);
	$zdata   = substr(substr($zdata, 0, strlen($zdata) - 4), 2); // fix crc bug
	$c_len   = strlen($zdata);
	$fr     .= pack('V', $crc);             // crc32
	$fr     .= pack('V', $c_len);           // compressed filesize
	$fr     .= pack('V', $unc_len);         // uncompressed filesize
	$fr     .= pack('v', strlen($name));    // length of filename
	$fr     .= pack('v', 0);                // extra field length
	$fr     .= $name;
	// "file data" segment
	$fr .= $zdata;
	# Datei speichern
	$laenge = strlen($fr);
	$this->tk_laengedaten += $laenge;
	fwrite($this->tk_fhtmpdat, $fr, $laenge);
	// now add to central directory record
	$cdrec  = "\x50\x4b\x01\x02";
	$cdrec .= "\x00\x00";                // version made by
	$cdrec .= "\x14\x00";                // version needed to extract
	$cdrec .= "\x00\x00";                // gen purpose bit flag
	$cdrec .= "\x08\x00";                // compression method
	$cdrec .= $hexdtime;                 // last mod time & date
	$cdrec .= pack('V', $crc);           // crc32
	$cdrec .= pack('V', $c_len);         // compressed filesize
	$cdrec .= pack('V', $unc_len);       // uncompressed filesize
	$cdrec .= pack('v', strlen($name)); // length of filename
	$cdrec .= pack('v', 0);             // extra field length
	$cdrec .= pack('v', 0);             // file comment length
	$cdrec .= pack('v', 0);             // disk number start
	$cdrec .= pack('v', 0);             // internal file attributes
	$cdrec .= pack('V', 32);            // external file attributes - 'archive' bit set
	$cdrec .= pack('V', $this->old_offset); // relative offset of local header
	$this->old_offset += strlen($fr);
	$cdrec .= $name;
	// optional extra field, file comment goes here
	// save to central directory
	$this->tk_metadaten .= $cdrec;
	$this->tk_dateien++;
	return true;
}

function unix2DosTime($unixtime = 0){
	$timearray = ($unixtime == 0)?getdate():getdate($unixtime);
	if($timearray['year'] < 1980){
		$timearray['year']    = 1980;
		$timearray['mon']     = 1;
		$timearray['mday']    = 1;
		$timearray['hours']   = 0;
		$timearray['minutes'] = 0;
		$timearray['seconds'] = 0;
	}
	return (($timearray['year'] - 1980) << 25) | ($timearray['mon'] << 21) | ($timearray['mday'] << 16) |
		($timearray['hours'] << 11) | ($timearray['minutes'] << 5) | ($timearray['seconds'] >> 1);
}

} # Ende der Klasse, EOF
?>