<?php
# Modul: wkabwickeln_dms
/*
Wettkampfabwicklung, Aktion: dms_aufstellungexportieren
verwendete Templates:
 - [keines]
*/
$_mannschaften = array();
foreach($_wkeinst['dms'] as $key => $schwimmer){
	$_mannschaften[$key] = array(
		'mw' => $key[0],
		'nr' => $key[1],
		'titel' => $key[1].'. Mannschaft '.$_geschlechter[$key[0]],
		'schwimmer' => empty($schwimmer)?false:explode('|', $schwimmer)

	);
}
$_strecken = require(PFAD_INCLUDE.'conf/dms-wettkampffolge.inc.php');
$_abschnitte = [1,2];

$fehler = [];
if(!isset($_wkeinst['wettkampfdaten']['startkarten'])){
	$fehler[] = 'Bitte erst Startkarten erzeugen.';
}
if(!isset($_wkeinst['dmsstreckenzuordnung'])){
	$fehler[] = 'Es wurden den Strecken noch keine Schwimmer zugeordnet.';
}
else{
	foreach($_mannschaften as $_m => $mannschaft){
		if(isset($_wkeinst['dmsstreckenzuordnung'][$_m])){
			continue;
		}
		$mwx = $_m[0]=='m'?'männlich':($_m[0]=='w'?'weiblich':'mixed');
		$fehler[] = 'Bei der '.$_m[1].'. Mannschaft '.$mwx.' wurden den Strecken noch keine Schwimmer zugeordnet.';
	}
}
if(count($fehler) > 0){
	$_tmpl->assign('fehler', implode('<br>', $fehler));
}

if(count($fehler) == 0){
	require_once(PFAD_INCLUDE.'class/pdf.inc.php');
	$pdf = new tkpdf;
	$pdf->ezSetMargins(20,20,50,20);
	$optionen = array(
		'aufstellung' => array(
			'fontSize' => 12,
			'titelFontSize' => 12,
			'xPos' => 60,
			'xOrientation' => 'right',
			'shaded' => 0,
			'showLines' => 2,
			'colGap' => 6,
			'rowGap' => 4,
			'innerLineThickness' => 0.5,
			'outerLineThickness' => 1.5,
			'cols' => array('name'=>array('width'=>230))
		),
		'teilnehmer' => array(
			'fontSize' => 10,
			'xPos' => 500,
			'xOrientation' => 'left',
			'shaded' => 0,
			'showLines' => 0,
			'rowGap' => 1,
			'cols' => array('namejg'=>array('width'=>200))
		)
	);
	$spalten = array(
		'aufstellung' => array(
			'abschn'=>'<b>Abs.</b>',
			'wknr'=>'<b>WK</b>',
			'lauf'=>'<b>L</b>',
			'bahn'=>'<b>B</b>',
			'strecke'=>'<b>Strecke</b>',
			'name'=>'<b>Name</b>'
		),
		'teilnehmer' => array(
			'namejg' => '<b>Mannschaft</b>'
		)
	);
	$erste = true;

	foreach($_mannschaften as $_m => $mannschaft){
		if(!$erste){
			$pdf->eznewpage();
		}
		$_mw = $_m[0];
		$_wknrplus = $_mw=='w'?1:2;
		# Schwimmer holen
		$_schwimmer = $_schwimmerjg = [];
		if(is_array($mannschaft['schwimmer'])){
			$query = "SELECT id, CONCAT(vorname, ' ', nachname) as name, CONCAT(vorname, ' ', nachname, ' (',YEAR(gebdatum),')') as namejg
						FROM ".DB_PREFIX."mitglieder
						WHERE id IN (".implode(',', $mannschaft['schwimmer']).")
						ORDER BY nachname, vorname";
			$_db->holeDaten($query);
			$_schwimmer = $_db->baueArray('name', 'id');
			$_schwimmerjg = $_db->baueArray('*', 'id');
		}

		# schon gespeicherte Strecken holen
		$strecken = array();
		if(isset($_wkeinst['dmsstreckenzuordnung']) and isset($_wkeinst['dmsstreckenzuordnung'][$_m])){
			$strecken = json_decode(str_replace("'",'"',$_wkeinst['dmsstreckenzuordnung'][$_m]), true);
		}

		$conf = json_decode(str_replace("'",'"',$_wkeinst['wettkampfdaten']['startkarten']), true);
		$conf = $conf['bv'];
		$bahn = $conf['_mannschaften'][$_m]['1bahn'];
		$lauf = $conf['_mannschaften'][$_m]['laeufe'][1];
		
		$daten = array();
		foreach($_abschnitte as $abschn){
			foreach($_strecken as $nr => $strecke){
				$strecke['laenge'] = ($strecke['laenge']=='1500' and $_mw=='w')?'800':$strecke['laenge'];
				$mid = $strecken[$abschn][$strecke['lage']][$strecke['laenge']];
				$zusammenlegung = (in_array($strecke['laenge'],$conf['zusammenlegung']) and $strecke['lage']==1);
				$daten[] = array(
					'abschn' => $abschn,
					'wknr' => $nr*2+$_wknrplus+($abschn-1)*count($_strecken)*2,
					'lauf'   => '',#$zusammenlegung?'1 '.($conf['zusammenlauf1']=='r'?'li.':'re.'):$lauf,
					'bahn'   => '',#$bahn,
					'strecke' => $strecke['laenge'].'m '.$_lagen[$strecke['lage']],
					'name' => $mid=='-'?'':$_schwimmer[$mid]
				);
				$bahn++;
				if($bahn > $conf['bahnen']){
					$bahn = 1;
				}
			}
		}
		
		$y = $pdf->ezText('<b>'.$mannschaft['titel'].'</b>',14);
		$pdf->ezSetDy(-5);
		$pdf->ezTable($daten, $spalten['aufstellung'] ,'', $optionen['aufstellung']);
		$pdf->ezSetDy(-30);
		$pdf->ezTable($_schwimmerjg, $spalten['teilnehmer'] ,'', $optionen['teilnehmer']);
		$erste = false;
	}
	$pdf->tk_titel = 'DMS Aufstellung';
	$pdf->tkstream('dms-aufstellung.pdf');
	exit;
}
# EOF
